<xsl:stylesheet xmlns:xsl = "http://www.w3.org/1999/XSL/Transform" version = "1.0" > 
	<xsl:output
		   method="xml"
		   encoding="UTF-8"
		   doctype-system="mga.dtd"
		   indent="yes"/>

		<xsl:template match = "node()|@*" > 
			<xsl:choose>
				<xsl:when test="name()='folder'">
				    <xsl:variable name="kind" select="@kind"></xsl:variable> 
				    <xsl:variable name="name" select="name"></xsl:variable> 
  				    <xsl:variable name="modelkind" select="model/@kind"></xsl:variable> 
  				    
					<xsl:choose>
						<xsl:when test="$kind='Package'">
							<xsl:element name="model">
								<xsl:copy-of select="node()|@*"/>
							</xsl:element>
						</xsl:when>
						<xsl:when test="$modelkind='ClassDiagram'">
							<folder>
								<xsl:copy-of select="@*"/>
								<xsl:copy-of select="name"/>
								<model>
									<xsl:attribute name="kind">Package</xsl:attribute>
									<xsl:element name="name">
										<xsl:value-of select="normalize-space($name)"/> 
									</xsl:element>
									<xsl:copy-of select = "model"/> 
							   </model>
						   </folder>
						</xsl:when>
						
						<xsl:when test="$kind='Configurations'">
							<xsl:variable name="modelatom" select="model[@kind='Configuration']/atom[@kind='UserCodeLibrary']"></xsl:variable> 							
							<folder>
								<xsl:copy-of select="@*"/>
								<xsl:copy-of select="name"/>
								<model>
									<xsl:attribute name="kind">CodeLibrary</xsl:attribute>
									<xsl:element name="name">
										<xsl:text>CodeLibrary</xsl:text>
									</xsl:element>
									<atom>
										<xsl:copy-of select="$modelatom/@*|$modelatom/node()"/>
									</atom>
								</model>
								<model>
									<xsl:copy-of select="model/@*"/>
									<xsl:copy-of select="model/name"/>
									<xsl:copy-of select="model/attribute"/>
									<xsl:copy-of select="model/model"/>
									<xsl:copy-of select="model/atom[@kind!='UserCodeLibrary']"/>
									<xsl:copy-of select="model/reference"/>
									<xsl:copy-of select="model/connection"/>
								</model>			
							</folder>													
						</xsl:when>
											
						<xsl:otherwise>
						   <xsl:copy > 
								<xsl:apply-templates select = "node()|@*" /> 
						   </xsl:copy> 
						</xsl:otherwise>
					</xsl:choose>
					
				</xsl:when>
				
				<xsl:otherwise>
				   <xsl:copy > 
						<xsl:apply-templates select = "node()|@*" /> 
				   </xsl:copy> 
				</xsl:otherwise>
			</xsl:choose>
        </xsl:template>
		
</xsl:stylesheet> 


