; Script generated by the Inno Setup Script Wizard.
; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

; Requires Inno Setup Preprocessor by Alex Yackimoff
#pragma option -v+
#pragma verboselevel 9

#define UDMVER "3.2, 3.2.13 or later"
; eg 3.2.4.0: 3.2 is implied by UDMDLL. First short is 4; second is 0
#define UDM_PATCH 00150000
#define UDMDLL "UdmDll_3_2.dll"

#define GREATPATH GetEnv('GREAT_PATH')
#define GREAT_3RDPARTY_PATH GetEnv('GREAT_3RDPARTY_PATH')

#define GREATVER GetEnv('GREAT_VERSION')
#if GREATVER == ""
#define GREATVER "1.7.8"
#endif

#define OutputFileBase "GReAT_setup"

[Setup]
AppID=ISIS GReAT
AppName=GReAT {#GREATVER}
AppVerName=ISIS GReAT v{#GREATVER}
AppVersion={#GREATVER}
AppPublisher=ISIS, Vanderbilt University
AppPublisherURL=http://www.escherinstitute.org/Plone/tools/suites/mic/great
AppSupportURL=http://www.escherinstitute.org/Plone/tools/suites/mic/great
AppUpdatesURL=http://www.escherinstitute.org/Plone/tools/suites/mic/great
DefaultDirName={pf}\ISIS\GReAT
DefaultGroupName=GReAT
LicenseFile={#GREATPATH}\license.txt
InfoBeforeFile={#GREATPATH}\releaseinfo.txt
SourceDir={#GREATPATH}
OutputDir={#GREATPATH}\InnoSetup
OutputBaseFilename={#OutputFileBase}
Compression=lzma
SolidCompression=yes
ChangesEnvironment=true
AppCopyright=Copyright (C) 2004-2010 ISIS, Vanderbilt University

[Languages]
Name: english; MessagesFile: compiler:Default.isl

[Types]
Name: Custom; Description: Custom Installation; Flags: iscustom
Name: Full; Description: Full Installation

[Components]
Name: G; Description: GReAT Package; Types: Full Custom; Flags: fixed
Name: M; Description: MetaGME2UML and MetaGME2UMT interpreters; Types: Full Custom; Flags: 
Name: S; Description: GReAT samples; Types: Full; Flags: 
Name: System; Description: Register Environment Variables System-Wide (recommended); Types: Full Custom

[Files]
; NOTE: Don't use "Flags: ignoreversion" on any shared system files
Source: {#GREATPATH}\releaseinfo.txt; DestDir: {app}; Components: G; Flags: ignoreversion; DestName: readme.txt
;GReAT Bin folder
;for Visual studio 2010
Source: {#GREATPATH}\Bin\boost_thread-vc100-mt-1_44.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin\CG.exe; DestDir: {app}\bin; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin\grd.exe; DestDir: {app}\bin; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin\GRE.exe; DestDir: {app}\bin; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin\GRCC.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion
; can't regserver until the VC10 runtime is installed. Do it in [Run]
Source: {#GREATPATH}\Bin\CodeGenerator.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin\GRD_interpreter.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin\GReAT Master Interpreter.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin\InvokeGRE.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion
;for Visual studio 2008
Source: {#GREATPATH}\Bin_vs9\boost_thread-vc90-mt-1_44.dll; DestDir: {app}\bin_vs9; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin_vs9\CG.exe; DestDir: {app}\bin_vs9; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin_vs9\grd.exe; DestDir: {app}\bin_vs9; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin_vs9\GRE.exe; DestDir: {app}\bin_vs9; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin_vs9\GRCC.dll; DestDir: {app}\bin_vs9; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin_vs9\CodeGenerator.dll; DestDir: {app}\bin_vs9; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin_vs9\GRD_interpreter.dll; DestDir: {app}\bin_vs9; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin_vs9\GReAT Master Interpreter.dll; DestDir: {app}\bin_vs9; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin_vs9\InvokeGRE.dll; DestDir: {app}\bin_vs9; Components: G; Flags: ignoreversion
;
Source: {#GREATPATH}\Bin\GenerateGRC.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion 
Source: {#GREATPATH}\Bin\LegacyUpdate.exe; DestDir: {app}\bin; Components: M; Flags: ignoreversion
Source: {#GREATPATH}\Bin\GenerateCfgModel.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion 
Source: {#GREATPATH}\Bin\GenerateConfig.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion 
Source: {#GREATPATH}\Bin\GenerateGR.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion 
Source: {#GREATPATH}\Bin\LibraryUpdate.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion 
Source: {#GREATPATH}\Bin\PortConnector.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion 
Source: {#GREATPATH}\Bin\UMTDecorator.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Bin\UMTHelper.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion 
Source: {#GREATPATH}\Bin\MetaGME2UML.exe; DestDir: {app}\bin; Components: M; Flags: ignoreversion
Source: {#GREATPATH}\Bin\MetaGME2Uml.dll; DestDir: {app}\bin; Components: M; Flags: ignoreversion 
Source: {#GREATPATH}\Bin\MetaGME2UMT.dll; DestDir: {app}\bin; Components: M; Flags: ignoreversion 
Source: {#GREATPATH}\Bin\CreateRule.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion 
Source: {#GREATPATH}\Bin\Blockify.dll; DestDir: {app}\bin; Components: G; Flags: ignoreversion 
;GReAT Doc folder
Source: {#GREATPATH}\Doc\GReAT_Presentation_at_ASE2003.ppt; DestDir: {app}\Doc; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Doc\GReAT User Manual.pdf; DestDir: {app}\Doc; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Doc\GReAT_TechnicalReport.pdf; DestDir: {app}\Doc; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Doc\Greater_Picture_Paper_at_OOPSLA2003.pdf; DestDir: {app}\Doc; Components: G; Flags: ignoreversion
Source: {#GREATPATH}\Doc\Step-by-step GReAT Guide.pdf; DestDir: {app}\Doc; Components: G; Flags: ignoreversion
;GReAT Etc folder
Source: {#GREATPATH}\Etc\GRC_make2008.bat; DestDir: {app}\etc; DestName: GRC_make2008.bat; Flags: ignoreversion
Source: {#GREATPATH}\Etc\GRC_make2010.bat; DestDir: {app}\etc; DestName: GRC_make2010.bat; Flags: ignoreversion
Source: {#GREATPATH}\Etc\RegParadigmXmp.vbs; DestDir: {app}\etc; Flags: deleteafterinstall
Source: {#GREATPATH}\Etc\CallRegParadigm.bat; DestDir: {app}\etc; Flags: deleteafterinstall
Source: {#GREATPATH}\Etc\gr.xsd; DestDir: {app}\etc; Flags: ignoreversion
Source: {#GREATPATH}\Etc\UmtUpdater.xsl; DestDir: {app}\etc; Flags: ignoreversion
Source: {#GREATPATH}\Etc\RunGReATMasterInt.vbs; DestDir: {app}\etc; Flags: ignoreversion
;GReAT inlcude folder
Source: {#GREATPATH}\include\GReATSort.h; DestDir: {app}\include; Flags: ignoreversion
Source: {#GREATPATH}\include\InputFileRegistry.h; DestDir: {app}\include; Flags: ignoreversion
Source: {#GREATPATH}\include\GReATUtils.h; DestDir: {app}\include; Flags: ignoreversion
Source: {#GREATPATH}\include\RTT.h; DestDir: {app}\include; Flags: ignoreversion
Source: {#GREATPATH}\include\RTTGenerator.h; DestDir: {app}\include; Flags: ignoreversion
;GReAT lib folder
;Visual studio 2010
Source: {#GREATPATH}\lib\GReATUtilsVC10.lib; DestDir: {app}\lib; Flags: ignoreversion
Source: {#GREATPATH}\lib\GReATUtilsVC10d.lib; DestDir: {app}\lib; Flags: ignoreversion
Source: {#GREATPATH}\lib\RTTGeneratorVC10.lib; DestDir: {app}\lib; Flags: ignoreversion
Source: {#GREATPATH}\lib\RTTGeneratorVC10d.lib; DestDir: {app}\lib; Flags: ignoreversion
;Visual studio 2008
Source: {#GREATPATH}\lib_vs9\GReATUtils.lib; DestDir: {app}\lib; Flags: ignoreversion
Source: {#GREATPATH}\lib_vs9\GReATUtilsd.lib; DestDir: {app}\lib; Flags: ignoreversion
Source: {#GREATPATH}\lib_vs9\RTTGenerator.lib; DestDir: {app}\lib; Flags: ignoreversion
Source: {#GREATPATH}\lib_vs9\RTTGeneratord.lib; DestDir: {app}\lib; Flags: ignoreversion
;GReAT Meta folder
Source: {#GREATPATH}\Meta\UMLModelTransformer.xmp; DestDir: {app}\Meta; Flags: ignoreversion
Source: {#GREATPATH}\Meta\UmlModelTransformer_meta.xme; DestDir: {app}\Meta; Flags: ignoreversion
Source: {#GREATPATH}\Meta\UmlModelTransformer_uml.xme; DestDir: {app}\Meta; Flags: ignoreversion
Source: {#GREATPATH}\Meta\GReATConfig.xmp; DestDir: {app}\Meta; Flags: ignoreversion
Source: {#GREATPATH}\Meta\GReATConfig_meta.xme; DestDir: {app}\Meta; Flags: ignoreversion
Source: {#GREATPATH}\Meta\GReATConfig_uml.xme; DestDir: {app}\Meta; Flags: ignoreversion
Source: {#GREATPATH}\Meta\RTT.xmp; DestDir: {app}\Meta; Flags: ignoreversion
Source: {#GREATPATH}\Meta\RTT_meta.xme; DestDir: {app}\Meta; Flags: ignoreversion
Source: {#GREATPATH}\Meta\RTT_uml.xme; DestDir: {app}\Meta; Flags: ignoreversion
Source: {#GREATPATH}\Meta\GR_uml.xme; DestDir: {app}\Meta; Flags: ignoreversion
Source: {#GREATPATH}\Meta\icons\*; DestDir: {app}\Meta\icons; Excludes: .svn; Flags: ignoreversion
;GReAT Sample folder
;	House2Order
Source: {#GREATPATH}\Samples\House2Order\House2Order.mga; DestDir: {commondocs}\GReAT Samples\House2Order
Source: {#GREATPATH}\Samples\House2Order\House2Order.xme; DestDir: {commondocs}\GReAT Samples\House2Order
Source: {#GREATPATH}\Samples\House2Order\Readme.pdf; DestDir: {commondocs}\GReAT Samples\House2Order
Source: {#GREATPATH}\Samples\House2Order\Meta\GS_Order.xmp; DestDir: {commondocs}\GReAT Samples\House2Order\Meta
Source: {#GREATPATH}\Samples\House2Order\Meta\HouseModel.xme; DestDir: {commondocs}\GReAT Samples\House2Order\Meta
Source: {#GREATPATH}\Samples\House2Order\Meta\GS_HouseModel.xmp; DestDir: {commondocs}\GReAT Samples\House2Order\Meta
Source: {#GREATPATH}\Samples\House2Order\Meta\Order.mga; DestDir: {commondocs}\GReAT Samples\House2Order\Meta
Source: {#GREATPATH}\Samples\House2Order\Meta\Order.xme; DestDir: {commondocs}\GReAT Samples\House2Order\Meta
Source: {#GREATPATH}\Samples\House2Order\Meta\HouseModel.mga; DestDir: {commondocs}\GReAT Samples\House2Order\Meta
Source: {#GREATPATH}\Samples\House2Order\Meta\icons\*; DestDir: {commondocs}\GReAT Samples\House2Order\Meta\icons; Excludes: .svn
Source: {#GREATPATH}\Samples\House2Order\Models\1_input_MyHouse1.mga; DestDir: {commondocs}\GReAT Samples\House2Order\Models
Source: {#GREATPATH}\Samples\House2Order\Models\1_input_MyHouse1.xme; DestDir: {commondocs}\GReAT Samples\House2Order\Models
;	MatchAnyAssoc
Source: {#GREATPATH}\Samples\MatchAnyAssoc\testMatchAnyAssoc.xme; DestDir: {commondocs}\GReAT Samples\MatchAnyAssoc
Source: {#GREATPATH}\Samples\MatchAnyAssoc\testMatchAnyAssoc.mga; DestDir: {commondocs}\GReAT Samples\MatchAnyAssoc
Source: {#GREATPATH}\Samples\MatchAnyAssoc\Readme.pdf; DestDir: {commondocs}\GReAT Samples\MatchAnyAssoc
Source: {#GREATPATH}\Samples\MatchAnyAssoc\Meta\GS_BidirectAssoc.xmp; DestDir: {commondocs}\GReAT Samples\MatchAnyAssoc\Meta
Source: {#GREATPATH}\Samples\MatchAnyAssoc\Meta\BidirectAssoc.xme; DestDir: {commondocs}\GReAT Samples\MatchAnyAssoc\Meta
Source: {#GREATPATH}\Samples\MatchAnyAssoc\Meta\BidirectAssoc.mga; DestDir: {commondocs}\GReAT Samples\MatchAnyAssoc\Meta
Source: {#GREATPATH}\Samples\MatchAnyAssoc\Models\1_input_BidirectAssoc_model.xme; DestDir: {commondocs}\GReAT Samples\MatchAnyAssoc\Models
Source: {#GREATPATH}\Samples\MatchAnyAssoc\Models\1_input_BidirectAssoc_model.mga; DestDir: {commondocs}\GReAT Samples\MatchAnyAssoc\Models
;	SF2FSF
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\Readme.pdf; DestDir: {commondocs}\GReAT Samples\SF2FSF
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\SignalFlow_test_distinguished.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF_test_globalObject.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF_test_sortingFunc.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\SignalFlow_test_distinguished.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF_test_globalObject.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF_test_sortingFunc.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\SignalFlow2FlatSF.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\meta\SignalFlow\GS_SignalFlow.xmp; DestDir: {commondocs}\GReAT Samples\SF2FSF\Meta
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\meta\SignalFlow\SignalFlow.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Meta
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\meta\SignalFlow\SignalFlow.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Meta
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\meta\FlatSF\GS_FlatSF.xmp; DestDir: {commondocs}\GReAT Samples\SF2FSF\Meta
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\meta\FlatSF\FlatSF.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Meta
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\meta\FlatSF\FlatSF.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Meta
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\meta\SignalFlow\icons\*; DestDir: {commondocs}\GReAT Samples\SF2FSF\Meta\icons; Excludes: .svn
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\meta\FlatSF\icons\*; DestDir: {commondocs}\GReAT Samples\SF2FSF\Meta\icons; Excludes: .svn
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\Models\1_input_SignalFlow_1.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\Models\2_input_SignalFlow_1.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\3_input_SignalFlow_2.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\SignalFlow_3.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\SignalFlow_4.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\SignalFlow_5.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\SignalFlow_6.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\SignalFlow_7.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\4_input_SignalFlow_to_connect.mga; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\1_input_SignalFlow_1.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\2_input_SignalFlow_1.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\3_input_SignalFlow_2.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\SignalFlow_3.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\SignalFlow_4.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\SignalFlow_5.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\SignalFlow_6.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\SignalFlow_7.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
Source: {#GREATPATH}\Samples\SignalFlow2FlatSF\models\4_input_SignalFlow_to_connect.xme; DestDir: {commondocs}\GReAT Samples\SF2FSF\Models
;	StateChart
Source: {#GREATPATH}\Samples\StateChart\Readme.pdf; DestDir: {commondocs}\GReAT Samples\StateChart
Source: {#GREATPATH}\Samples\StateChart\HSM2FSM.xme; DestDir: {commondocs}\GReAT Samples\StateChart
Source: {#GREATPATH}\Samples\StateChart\HSM2FSM.mga; DestDir: {commondocs}\GReAT Samples\StateChart
Source: {#GREATPATH}\Samples\StateChart\Meta\GS_StateChart.xmp; DestDir: {commondocs}\GReAT Samples\StateChart\Meta
Source: {#GREATPATH}\Samples\StateChart\Meta\FiniteStateMachine.mga; DestDir: {commondocs}\GReAT Samples\StateChart\Meta
Source: {#GREATPATH}\Samples\StateChart\Meta\StateChart.mga; DestDir: {commondocs}\GReAT Samples\StateChart\Meta
Source: {#GREATPATH}\Samples\StateChart\Meta\FiniteStateMachine.xme; DestDir: {commondocs}\GReAT Samples\StateChart\Meta
Source: {#GREATPATH}\Samples\StateChart\Meta\StateChart.xme; DestDir: {commondocs}\GReAT Samples\StateChart\Meta
Source: {#GREATPATH}\Samples\StateChart\Meta\GS_FiniteStateMachine.xmp; DestDir: {commondocs}\GReAT Samples\StateChart\Meta
Source: {#GREATPATH}\Samples\StateChart\Meta\icons\*; DestDir: {commondocs}\GReAT Samples\StateChart\icons; Excludes: .svn
Source: {#GREATPATH}\Samples\StateChart\Models\3BitCounter.xme; DestDir: {commondocs}\GReAT Samples\StateChart\Models
Source: {#GREATPATH}\Samples\StateChart\Models\1_input_2BitCounter.mga; DestDir: {commondocs}\GReAT Samples\StateChart\Models
Source: {#GREATPATH}\Samples\StateChart\Models\3BitCounter.mga; DestDir: {commondocs}\GReAT Samples\StateChart\Models
Source: {#GREATPATH}\Samples\StateChart\Models\1_input_2BitCounter.xme; DestDir: {commondocs}\GReAT Samples\StateChart\Models
;	SignalFlowGroup
Source: {#GREATPATH}\Samples\SignalFlowGroup\Readme.pdf; DestDir: {commondocs}\GReAT Samples\SignalFlowGroup
Source: {#GREATPATH}\Samples\SignalFlowGroup\MoveSignalFlowGroup.mga; DestDir: {commondocs}\GReAT Samples\SignalFlowGroup
Source: {#GREATPATH}\Samples\SignalFlowGroup\MoveSignalFlowGroup.xme; DestDir: {commondocs}\GReAT Samples\SignalFlowGroup
Source: {#GREATPATH}\Samples\SignalFlowGroup\Meta\GS_SignalFlowGroup.xme; DestDir: {commondocs}\GReAT Samples\SignalFlowGroup\Meta
Source: {#GREATPATH}\Samples\SignalFlowGroup\Meta\GS_SignalFlowGroup.mga; DestDir: {commondocs}\GReAT Samples\SignalFlowGroup\Meta
Source: {#GREATPATH}\Samples\SignalFlowGroup\Meta\GS_SignalFlowGroup.xmp; DestDir: {commondocs}\GReAT Samples\SignalFlowGroup\Meta
Source: {#GREATPATH}\Samples\SignalFlowGroup\Meta\icons\*; DestDir: {commondocs}\GReAT Samples\SignalFlowGroup\Meta\icons; Excludes: .svn
Source: {#GREATPATH}\Samples\SignalFlowGroup\Models\1_input_mySignalFlow1.xme; DestDir: {commondocs}\GReAT Samples\SignalFlowGroup\Models
Source: {#GREATPATH}\Samples\SignalFlowGroup\Models\1_input_mySignalFlow1.mga; DestDir: {commondocs}\GReAT Samples\SignalFlowGroup\Models

Source: {#GREATPATH}\VC9Redist\bin\Release\VC9Redist.msi; DestDir: "{tmp}"
Source: {#GREATPATH}\VC10Redist\bin\Release\VC10Redist.msi; DestDir: "{tmp}"

Source: {#GREAT_3RDPARTY_PATH}\mpc\*; Destdir: {app}\3rdparty\mpc; Flags: recursesubdirs; Excludes: .svn

[Dirs]
Name: {app}\etc; Components: G
Name: {app}\Meta; Components: G
;; TODO: delete on uninstall?
Name: {commondocs}\GReAT Samples; Components: S

[Messages]
SelectComponentsLabel2=Select the setup type that best suits your needs. Click Next when you are ready to continue.

[Registry]
Root: HKCU; Subkey: Environment; ValueType: string; ValueName: GREAT_PATH; ValueData: {app}; Flags: uninsdeletevalue deletevalue; Components: not System
Root: HKLM; Subkey: SYSTEM\CurrentControlSet\Control\Session Manager\Environment; ValueType: string; ValueName: GREAT_PATH; ValueData: {app}; Flags: uninsdeletevalue deletevalue; Components: System
Root: HKCU; Subkey: Environment; ValueType: string; ValueName: GREAT_3RDPARTY_PATH; ValueData: {app}\3rdparty; Flags: uninsdeletevalue deletevalue; Components: not System
Root: HKLM; Subkey: SYSTEM\CurrentControlSet\Control\Session Manager\Environment; ValueType: string; ValueName: GREAT_3RDPARTY_PATH; ValueData: {app}\3rdparty; Flags: uninsdeletevalue deletevalue; Components: System

[Code]
var
  InstallSystemWide: Boolean;
  VSVerOptionPage: TInputOptionWizardPage;
  has_vs2010: Boolean;
  has_vs2008: Boolean;
  preferred_vsversion: (vs2008, vs2010);
  vs_path : String;

procedure InitializeWizard;
begin
	has_vs2010 := false;
	has_vs2008 := false;
	vs_path := '';
	RegQueryStringValue(HKEY_LOCAL_MACHINE, 'SOFTWARE\MicroSoft\VisualStudio\10.0', 'InstallDir', vs_path);
	if vs_path <> '' then begin
		has_vs2010 := true;
	end else begin
		RegQueryStringValue(HKEY_LOCAL_MACHINE, 'SOFTWARE\MicroSoft\VCExpress\10.0', 'InstallDir', vs_path);
		if vs_path <> '' then begin
			has_vs2010 := true;
		end;
	end;
	vs_path := '';
	RegQueryStringValue(HKEY_LOCAL_MACHINE, 'SOFTWARE\MicroSoft\VisualStudio\9.0', 'InstallDir', vs_path);
	if vs_path <> '' then begin
		has_vs2008 := true;
	end else begin
		RegQueryStringValue(HKEY_LOCAL_MACHINE, 'SOFTWARE\MicroSoft\VCExpress\9.0', 'InstallDir', vs_path);
		if vs_path <> '' then begin
			has_vs2008 := true;
		end;
	end;
	if (has_vs2010 AND has_vs2008) OR not(has_vs2010 OR has_vs2008) then begin
		VSVerOptionPage := CreateInputOptionPage(wpInfoBefore,'Visual Studio','Info','Which version of Visual Studio should GReAT use by default?',true,False);
		VSVerOptionPage.Add('Visual Studio 2010');
		VSVerOptionPage.Add('Visual Studio 2008');
		VSVerOptionPage.Values[0] := True;
	end else begin
	  if has_vs2010 then begin
	    preferred_vsversion := vs2010;
	  end else begin
	    preferred_vsversion := vs2008;
	  end
	end;
end;

function CheckVersions(): Boolean;
var
  MS, LS: Cardinal;
begin
  Result := True;
#ifdef UDMVER
  if GetVersionNumbers(ExpandConstant('{sys}\\{#UDMDLL}'), MS, LS) then begin
    // MS is checked through dll name
    if LS < ${#UDM_PATCH} then begin
      Result := Result and (MsgBox('This version of GReAT ({#GREATVER}) requires UDM {#UDMVER}. ' +
        'The current version of UDM is ' + Format('%d.%d.%d', [MS shr 16, MS and $FFFF, LS shr 16]) + '. ' +
        'Are you sure you wish to continue the installation?', mbConfirmation, MB_YESNO) = idYes);
    end
  end else begin
    Result := Result and (MsgBox('This version of GReAT ({#GREATVER}) is recommended for use with UDM {#UDMVER}. ' +
      'GReAT setup could not find {#UDMDLL} and will not operate correctly without it.'#13#13 +
      'Are you sure you wish to continue the installation?', mbConfirmation, MB_YESNO) = idYes);
  end
#endif
	if (not has_vs2010) and (not has_vs2008) then begin
		Result := Result and (MsgBox('Neither Visual Studio 2008 nor Visual Studio 2010 is installed. GReAT {#GREATVER} needs Visual Studio 2008 or Visual Studio 2010 to run.'+#13#13 +
		'Do you really want to install GReAT {#GREATVER} on your machine?', mbConfirmation, MB_YESNO) = idYes);
	end;
end;

function InitializeUninstall(): Boolean;
begin
  //Need to know if this was a system wide install or not
  InstallSystemWide := RegValueExists(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'GREAT_PATH');
  Result := True;
end;

Procedure ModPath(const ValueName, pathdir: String);
var
	oldpath:	String;
	newpath:	String;
	pathArr:	TArrayOfString;
	i:			Integer;
begin
	// Modify WinNT path
	if UsingWinNT() = true then begin
		// Get current path, split into an array
		if InstallSystemWide then begin
		  RegQueryStringValue(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', ValueName, oldpath);
		end else begin
		  RegQueryStringValue(HKEY_CURRENT_USER, 'Environment', ValueName, oldpath);
    end;
		if oldpath <> '' then
			oldpath := oldpath + ';';
		i := 0;
		while (Pos(';', oldpath) > 0) do begin
			SetArrayLength(pathArr, i+1);
			pathArr[i] := Copy(oldpath, 0, Pos(';', oldpath)-1);
			oldpath := Copy(oldpath, Pos(';', oldpath)+1, Length(oldpath));
			i := i + 1;

			// Check if current directory matches app dir
			if pathdir = pathArr[i-1] then begin
				// if uninstalling, remove dir from path
				if IsUninstaller() = true then begin
					continue;
				// if installing, abort because dir was already in path
				end else begin
					exit;
				end;
			end;

			// Add current directory to new path
			if i = 1 then begin
				newpath := pathArr[i-1];
			end else begin
				newpath := newpath + ';' + pathArr[i-1];
			end;
		end;

		// Append app dir to path if not already included
		if IsUninstaller() = false then begin
			if newpath <> '' then begin
				newpath := newpath + ';' + pathdir;
			end else begin
				newpath := pathdir;
			end;
		end;

		// Write new path
		if InstallSystemWide then begin
		  RegWriteStringValue(HKEY_LOCAL_MACHINE, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', ValueName, newpath);
		end else begin
		  RegWriteStringValue(HKEY_CURRENT_USER, 'Environment', ValueName, newpath);
    end;
	end;
end;

procedure CurStepChanged(CurStep: TSetupStep);
var
	path : String;
begin
	if CurStep = ssInstall then begin
		path := ExpandConstant('{app}');
//		RegWriteStringValue(HKEY_CURRENT_USER, 'Environment', 'GREAT_PATH', path);
		//Append bin, etc to Path
		ModPath('PATH', path+'\bin');
		ModPath('PATH', path+'\etc');
	end;
end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
var
	path : String;
begin
	if CurUninstallStep = usUninstall then begin
		path := ExpandConstant('{app}');
		//Remove bin, etc from path
		ModPath('PATH', path+'\bin');
		ModPath('PATH', path+'\etc');
		//Unregister paradigms
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\UMLModelTransformer');
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\GReATConfig');
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\RTT');
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\GS_Order');
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\GS_HouseModel');
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\GS_BidirectAssoc');
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\GS_SignalFlow');
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\GS_FlatSF');
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\GS_StateChart');
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\GS_FiniteStateMachine');
		RegDeleteKeyIncludingSubkeys(HKEY_CURRENT_USER, 'Software\GME\Paradigms\GS_SignalFlowGroup');
	end;
end;

function NextButtonClick(CurPageID: Integer): Boolean;
var
  MyComponents : String;
  MyCompLen : Integer;
begin
  Result := True;
  if CurPageID = wpSelectComponents then begin
    MyComponents := WizardSelectedComponents(false);
    MyCompLen := length(MyComponents);
    if MyComponents[MyCompLen] = 'm' then begin
      InstallSystemWide := true;
    end else begin
      InstallSystemWide := false;
    end;
  end;
  if (CurPageID = wpInfoBefore) and not WizardSilent() then begin
    Result := CheckVersions();
  end;
  if ((VSVerOptionPage <> nil) and (CurPageID = VSVerOptionPage.ID)) then begin
    if VSVerOptionPage.Values[0] then begin
      preferred_vsversion := vs2010;
    end else begin
      preferred_vsversion := vs2008;
    end;
	has_vs2010 := VSVerOptionPage.Values[0];
	has_vs2008 := VSVerOptionPage.Values[1];
  end;
end;

function UnassociateVS2008(): Boolean;
begin
  Result := (preferred_vsversion <> VS2008);
end;

function UnassociateVS2010(): Boolean;
begin
  Result := (preferred_vsversion <> VS2010);
end;

[Run]
Filename: "msiexec.exe"; Parameters: "/i ""{tmp}\VC9Redist.msi"""
Filename: "msiexec.exe"; Parameters: "/i ""{tmp}\VC10Redist.msi"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\CodeGenerator.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\GRD_interpreter.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\GReAT Master Interpreter.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\InvokeGRE.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\GenerateGRC.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\GenerateCfgModel.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\GenerateConfig.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\GenerateGR.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\LibraryUpdate.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\PortConnector.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\MetaGME2UMT.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\CreateRule.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\Blockify.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin_vs9\CodeGenerator.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin_vs9\GRD_interpreter.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin_vs9\GReAT Master Interpreter.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin_vs9\InvokeGRE.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\UMTDecorator.dll"""
Filename: "regsvr32.exe"; Parameters: "/s ""{app}\bin\UMTHelper.dll"""

Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{app}\Meta\UMLModelTransformer.xmp"""; Flags: skipifdoesntexist runhidden
Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{app}\Meta\GReATConfig.xmp"""; Flags: skipifdoesntexist runhidden
Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{app}\Meta\RTT.xmp"""; Flags: skipifdoesntexist runhidden
Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{commondocs}\GReAT Samples\House2Order\Meta\GS_Order.xmp"""; Flags: skipifdoesntexist runhidden
Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{commondocs}\GReAT Samples\House2Order\Meta\GS_HouseModel.xmp"""; Flags: skipifdoesntexist runhidden
Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{commondocs}\GReAT Samples\MatchAnyAssoc\Meta\GS_BidirectAssoc.xmp"""; Flags: skipifdoesntexist runhidden
Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{commondocs}\GReAT Samples\SF2FSF\Meta\GS_SignalFlow.xmp"""; Flags: skipifdoesntexist runhidden
Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{commondocs}\GReAT Samples\SF2FSF\Meta\GS_FlatSF.xmp"""; Flags: skipifdoesntexist runhidden
Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{commondocs}\GReAT Samples\StateChart\Meta\GS_StateChart.xmp"""; Flags: skipifdoesntexist runhidden
Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{commondocs}\GReAT Samples\StateChart\Meta\GS_FiniteStateMachine.xmp"""; Flags: skipifdoesntexist runhidden
Filename: {app}\etc\CallRegParadigm.bat; Parameters: """{commondocs}\GReAT Samples\SignalFlowGroup\Meta\GS_SignalFlowGroup.xmp"""; Flags: skipifdoesntexist runhidden

; If a user has both VS2010 and VS2008 (or neither), unassociate (i.e. untoggle) the other according to the choice in VSVerOptionPage
; n.b. can't do this in [Registry] since [Registry] comes after regserver
Filename: reg; Parameters: "delete ""HKCU\Software\GME\Components\MGA.Interpreter.GReAT Master Interpreter\Associated"" /v UMLModelTransformer /f"; Check: UnassociateVS2008(); Flags: runhidden
Filename: reg; Parameters: "delete ""HKCU\Software\GME\Components\MGA.Interpreter.GReAT Master Interpreter VC10\Associated"" /v UMLModelTransformer /f"; Check: UnassociateVS2010(); Flags: runhidden
Filename: reg; Parameters: "delete ""HKCU\Software\GME\Components\Generate code from rules\Associated"" /v UMLModelTransformer /f"; Check: UnassociateVS2008(); Flags: runhidden
Filename: reg; Parameters: "delete ""HKCU\Software\GME\Components\MGA.Interpreter.GReAT_CG_VC10\Associated"" /v UMLModelTransformer /f"; Check: UnassociateVS2010(); Flags: runhidden
Filename: reg; Parameters: "delete ""HKCU\Software\GME\Components\MGA.Interpreter.GRD_interpreter\Associated"" /v UMLModelTransformer /f"; Check: UnassociateVS2008(); Flags: runhidden
Filename: reg; Parameters: "delete ""HKCU\Software\GME\Components\MGA.Interpreter.GRD_interpreter_VC10\Associated"" /v UMLModelTransformer /f"; Check: UnassociateVS2010(); Flags: runhidden
Filename: reg; Parameters: "delete ""HKCU\Software\GME\Components\MGA.Interpreter.InvokeGRengine\Associated"" /v UMLModelTransformer /f"; Check: UnassociateVS2008(); Flags: runhidden
Filename: reg; Parameters: "delete ""HKCU\Software\GME\Components\MGA.Interpreter.InvokeGRengine_VC10\Associated"" /v UMLModelTransformer /f"; Check: UnassociateVS2010(); Flags: runhidden

[UninstallDelete]
Name: {app}\Meta\UmlModelTransformer.mta; Type: files
Name: {app}\Meta\GReATConfig.mta; Type: files
Name: {app}\Meta\RTT.mta; Type: files
Name: {commondocs}\GReAT Samples\House2Order\Meta\GS_HouseModel.mta; Type: files
Name: {commondocs}\GReAT Samples\House2Order\Meta\GS_Order.mta; Type: files
Name: {commondocs}\GReAT Samples\MatchAnyAssoc\Meta\GS_BidirectAssoc.mta; Type: files
Name: {commondocs}\GReAT Samples\SF2FSF\Meta\GS_FlatSF.mta; Type: files
Name: {commondocs}\GReAT Samples\SF2FSF\Meta\GS_SignalFlow.mta; Type: files
Name: {commondocs}\GReAT Samples\StateChart\Meta\GS_FiniteStateMachine.mta; Type: files
Name: {commondocs}\GReAT Samples\StateChart\Meta\GS_StateChart.mta; Type: files
Name: {commondocs}\GReAT Samples\SignalFlowGroup\Meta\GS_SignalFlowGroup.mta; Type: files

[Icons]
Name: {group}\Documents\GReAT User Manual; Filename: {app}\Doc\GReAT User Manual.pdf
Name: {group}\Documents\GReAT Tutorial; Filename: {app}\Doc\Step-by-step GReAT Guide.pdf
Name: {group}\Documents\GReAT Greater Picture; Filename: {app}\Doc\Greater_Picture_Paper_at_OOPSLA2003.pdf
Name: {group}\Documents\GReAT Technical Report; Filename: {app}\Doc\GReAT_TechnicalReport.pdf
Name: {group}\Samples\House2Order\Readme; Filename: {commondocs}\GReAT Samples\House2Order\Readme.pdf
Name: {group}\Samples\House2Order\House2Order; Filename: {commondocs}\GReAT Samples\House2Order\House2Order.mga
Name: {group}\Samples\MatchAnyAssoc\Readme; Filename: {commondocs}\GReAT Samples\MatchAnyAssoc\Readme.pdf
Name: {group}\Samples\MatchAnyAssoc\MatchAnyAssoc; Filename: {commondocs}\GReAT Samples\MatchAnyAssoc\testMatchAnyAssoc.mga
Name: {group}\Samples\SF2FSF\Readme; Filename: {commondocs}\GReAT Samples\SF2FSF\Readme.pdf
Name: {group}\Samples\SF2FSF\SF2FSF; Filename: {commondocs}\GReAT Samples\SF2FSF\SignalFlow2FlatSF.mga
Name: {group}\Samples\SF2FSF\SF2FSF_Global; Filename: {commondocs}\GReAT Samples\SF2FSF\SignalFlow2FlatSF_test_globalObject.mga
Name: {group}\Samples\SF2FSF\SF2FSF_Sorting; Filename: {commondocs}\GReAT Samples\SF2FSF\SignalFlow2FlatSF_test_sortingFunc.mga
Name: {group}\Samples\SF2FSF\SF_Distinguished; Filename: {commondocs}\GReAT Samples\SF2FSF\SignalFlow_test_distinguished.mga
Name: {group}\Samples\SignalFlowGroup\Readme; Filename: {commondocs}\GReAT Samples\SignalFlowGroup\Readme.pdf
Name: {group}\Samples\SignalFlowGroup\MoveSignalFlowGroup; Filename: {commondocs}\GReAT Samples\SignalFlowGroup\MoveSignalFlowGroup.mga
Name: {group}\Samples\StateChart\Readme; Filename: {commondocs}\GReAT Samples\StateChart\Readme.pdf
Name: {group}\Samples\StateChart\StateChart2FSM; Filename: {commondocs}\GReAT Samples\StateChart\HSM2FSM.mga
Name: {group}\Uninstall GReAT; Filename: {uninstallexe}
