#include <iostream>
#include <UdmBase.h>
#include "GReATConfig.h"
#include "GReATConfigMeta.h"
#include "GReATConfigUsage.h"
#include "GReATConfigRuntime.h"

int usage()
{
	std::cout << "Usage: GC_test.exe <GReATConfig file.mga>\n\n";
	return 1;
}

int testObjectPathElemParser()
{
	// just to please GReATConfigUsage constructor.
	GReATConfig::UsageInformation usageInfo;
	GReATConfigUsage usage( usageInfo);
	//
	const std::string test1= "type1";
	const std::string test2= "type2{}";
	const std::string test3= "type3{attr1=\"string1\"}";
	const std::string test4= "type4{attr1=0.0}";
	const std::string test5= "type5{attr1=\"string1\",attr2=0.0}";
	const std::string test6= "type6{attr1=\"string1\",attr2=0.0,attr3=\"string3\"}";
	const std::string test7= "type6{attr1\"string1\",attr2=0.0,attr3=\"string3\"}";
	//
	std::string type;
	std::vector< std::pair< std::string, std::string> >  attrs;
	usage.parseObjectPathElem( test1, type, attrs);
	usage.parseObjectPathElem( test2, type, attrs);
	usage.parseObjectPathElem( test3, type, attrs);
	usage.parseObjectPathElem( test4, type, attrs);
	usage.parseObjectPathElem( test5, type, attrs);
	usage.parseObjectPathElem( test6, type, attrs);
	usage.parseObjectPathElem( test7, type, attrs);
	return 0;
}


int main( int argc, char* argv[])
{
	if (2 !=argc)
		return usage();
//	return testObjectPathElemParser();
	try
	{
		std::string configFileName( argv[ 1]);
		Udm::SmartDataNetwork sdnConfig( GReATConfig::diagram);
		sdnConfig.OpenExisting( configFileName, "GReATConfig.xsd", Udm::CHANGES_LOST_DEFAULT);
		GReATConfig::RootFolder root= GReATConfig::RootFolder::Cast( sdnConfig.GetRootObject());
		GReATConfig::MetaInformation metaInfo= root.MetaInformation_child();
		GReATConfigMeta metaConfig( metaInfo);
		std::map< std::string, const Udm::DataNetwork*> dns;
		metaConfig.getGeneralBackend( dns);
		std::cout << dns.size() << std::endl;
	}
	catch(udm_exception &e)
	{
		cout << e.what() << endl;
	}

	return 0;
}
