#pragma warning( disable : 4786)

#include "GReATConfigRuntime.h"
#include "GReATConfig.h"

void GReATConfigRuntime::getInputFiles( std::set< GReATConfig::InputFile>& inputFiles)
{
	inputFiles= _runtimeInfo.InputFile_kind_children();
}

bool GReATConfigRuntime::getFileName( const std::string& fileID, std::string& fname)
{
	GReATConfig::InputFile inputFile;
	if ( false == getInputFile( fileID, inputFile))
		return false;
	fname= inputFile.FileName();
	return true;
}

bool GReATConfigRuntime::getCopyName( const std::string& fileID, std::string& cname)
{
	GReATConfig::InputFile inputFile;
	if ( false == getInputFile( fileID, inputFile))
		return false;
	cname= inputFile.CopyName();
	return true;
}

bool GReATConfigRuntime::getInputFile( const std::string& fileID, GReATConfig::InputFile& inputFile)
{
	if ( _inputFileMap.empty())
	{
		// fill map initially.
		const std::set< GReATConfig::InputFile>& inputFiles= _runtimeInfo.InputFile_kind_children();
		for( std::set< GReATConfig::InputFile>::const_iterator i= inputFiles.begin(); i!= inputFiles.end(); ++i)
		{
			_inputFileMap[ ( std::string)i->FileID()]= *i;
		}
	}
	// search
	std::map< std::string, GReATConfig::InputFile>::const_iterator itFind= _inputFileMap.find( fileID);
	if ( _inputFileMap.end() == itFind)
		return false;
	inputFile= itFind->second;
	return true;	
}
