#ifndef IGREAT_H
#define IGREAT_H

#include "GReATTypes.h"

class IGReAT 
{
public:

class ICtrlNotify
{
public:
  virtual  void reportProgress(double) {}
  virtual  void reportExcuteRule(const string &rule) {}

  virtual  bool quit() {return false;}
};

class IDebugNotify
{
public:

   

  virtual void stepIn(const GR::RuleBase& rule,
                      const PassAlongPackets& arguments) 
                      {}

  virtual void step(const GR::RuleBase& caller, 
            const GR::RuleBase& callee,
            const PassAlongPackets& arguments) 
            {}

  virtual void stepOut(const GR::RuleBase& rule, 
                        const PassAlongPackets& arguments,
                        const MatchVector& match = MatchVector()) 
               {}
};

public :

  virtual ~IGReAT() {}
  virtual void init(GeneralBackendPtr dataNetworkMap, 
                    Udm::DataNetwork *Transformation) = 0;
  virtual void setCINTDll(HINSTANCE hDLL) = 0;
  virtual PassAlongPackets Execute(const GR::RewritingRule& rule, 
                            const PassAlongPackets& agruments) = 0;

  virtual  void setDebugNotify(IDebugNotify*) = 0;
  virtual  void setCtrlNotify(ICtrlNotify*) = 0;

  virtual  void RemoveDuplicates(PassAlongPackets& ps) = 0;

};
 

#endif //IGREAT_H

