#include "GRCLoader.h"

typedef bool (*MAP_FN)(Uml::Diagram&);

HINSTANCE GRCLoader::loadDll()
{
	_hDLL = LoadLibrary( _dllFullName.c_str());
	if (_hDLL == 0) {
		TCHAR cTemp[256];
		DWORD dTemp = GetLastError();
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, 0, dTemp, 0, cTemp, 256, NULL);
		throw udm_exception(static_cast<std::string>("Cannot load '") + _dllFullName + ": " + static_cast<std::string>(cTemp));
	}

	StrUmlDiagrams_t::iterator it = _metas.begin();
	for(;it != _metas.end(); ++it)
	{
		const std::string& mn = (*it).first;
		std::string fn = "gz__init_" + mn ;
		MAP_FN lpMapFn = (MAP_FN)GetProcAddress( _hDLL, fn.c_str());
		bool err = lpMapFn((*it).second);
		if (err)
			throw udm_exception("Dll initialization failed");
	}
	return _hDLL; 
}

void GRCLoader::closeDll()
{
	if (_hDLL) {
		FreeLibrary( _hDLL);
		_hDLL = 0;
	}
}