#ifndef GRCMPCGEN_H
#define GRCMPCGEN_H

#include <list>
#include <string>

typedef std::list< std::string> StrList_t;

class GRCMPCGen {
public:
	virtual void generate( const std::string& fn, const std::string& metaDir, const StrList_t& metas)= 0;
};

// outputs: fn.mpc
class GRCMPCDynamicGen : public GRCMPCGen {
public:
	void generate( const std::string& fn, const std::string& metaDir, const StrList_t& metas);
};

// outputs: fn_code.mpc, fn_meta.mpc, fn_order.mpc
class GRCMPCStaticGen : public GRCMPCGen {
public:
	void generate( const std::string& fn, const std::string& metaDir, const StrList_t& metas);
};

class GRCMPCExeUsingNoLibGen : public GRCMPCGen {
public:
	GRCMPCExeUsingNoLibGen( const std::string& projname) : _projname( projname) {}
	void generate( const std::string& fn, const std::string& metaDir, const StrList_t& metas);
private:
	std::string _projname;
};

class GRCMPCExeUsingStaticLibGen : public GRCMPCGen {
public:
	GRCMPCExeUsingStaticLibGen( const std::string& projname) : _projname( projname) {}
	void generate( const std::string& fn, const std::string& metaDir, const StrList_t& metas);
private:
	std::string _projname;
};

#endif //GRCMPCGEN_H