#ifndef GRCNames_H
#define GRCNames_H

#include <string>
#include "GRCExport.h"

class GRCC_DLL GRCNames {
public:
	static std::string generateDllName( const std::string& fnamebase, bool debug) {
		if ( debug) {
			return fnamebase + "d.dll";
		} else {
			return fnamebase + ".dll";
		}
	}
	static std::string generateCodeLibName( const std::string& fnamebase, bool debug) {
		if ( debug) {
			return fnamebase + "_codesd.lib";
		} else {
			return fnamebase + "_codes.lib";
		}
	}
	static std::string generateMetaLibName( const std::string& fnamebase, bool debug) {
		if ( debug) {
			return fnamebase + "_metasd.lib";
		} else {
			return fnamebase + "_metas.lib";
		}
	}
	static std::string generateOrderLibName( const std::string& fnamebase, bool debug) {
		if ( debug) {
			return fnamebase + "_ordersd.lib";
		} else {
			return fnamebase + "_orders.lib";
		}
	}
};

#endif //GRCNames_H