#ifndef GRCPRINTER_H
#define GRCPRINTER_H

#include <string>
#include <fstream>
#include "GR.h"

///////////////////////////////////////////////////////////////////////////////
typedef std::list< std::string> StrList_t;

///////////////////////////////////////////////////////////////////////////////
class GRCPrinter : public GR::Visitor {
public:
	GRCPrinter( const std::string& filename, const StrList_t& metanames) 
		: _filename( filename), _metanames( metanames) {}
	virtual void Visit_RootFolder(const GR::RootFolder&);

protected:
	virtual void Visit_RewritingRule(const GR::RewritingRule&);
	bool MakeGuardFunction(const GR::RewritingRule& rule);
	bool MakeAttributeMappingFunction(const GR::RewritingRule& rule);
	void CreateSignature(const GR::RewritingRule& rule, char *sigvar, char *ret, bool onlyBoundObjects);
	void CreateGroupAMSignature(const GR::RewritingRule& rule);
	void createBlockEnd(bool);
	bool MakeGroupFunction(const GR::RewritingRule& rule);
	void CreateGroupFuncSignature(const GR::RewritingRule& rule);
	bool HasNullReference(const GR::RewritingRule& rule);

private:
	std::string _filename;
	StrList_t _metanames;
	StrList_t _rulepath;
	std::ofstream _cppfile, _deffile, _headerfile;
};

#endif //GRCPRINTER_H

