echo off
REM	* runGReATSample.bat <UMTmodel> <configFile> <udmFile> <outputmodel> <comparedmodel> 
REM			     <backend_meta_file> <genbase> <XSD>
REM	*
REM	* This batch file runs a GReAT sample
REM	*	- run master interpreter on the sample's transformation model
REM	*	- run gre.exe on the configuration file
REM	*	- unzip the udm file
REM	*	- compare the output model with the known-correct model
REM	*	- run cg.exe
REM	*
REM	* Arguments:
REM	*	1. <UMTmodel>: 		The transformation model (.mga)
REM	*	2. <ConfigFile>: 	The configuration file
REM	*	3. <udmFile>: 		The project udm file
REM	*	4. <outputmodel>: 	The outputmodel generated by running gre
REM	*	5. <comparedmodel>: 	The correct model used for comparison
REM	*	6. <backend_meta_file>: The meta backend XML file for comparing models	
REM	*	7. <genbase>: 		The name base for code generator
REM	*	8. <XSD>: 		The xsd file used needed for XML model for comparison

echo on
"%GREAT_PATH%/etc/RunGReATMasterInt.vbs" "%CD%\%1"
IF NOT %ERRORLEVEL%==0 GOTO RunMasIntError

If %~x3==".xml" GOTO checkXSD
cd Udm
unzip -o %3
cd ..

:checkXSD
IF "%8"=="" goto SkipCopyXSD
cd models
copy ..\udm\%8 /y
cd ..

:SkipCopyXSD
"%GREAT_PATH%/bin/GRE.exe" %2
IF NOT %ERRORLEVEL%==0 GOTO RunGREError

cd models
"%GREAT_PATH%/bin/UdmModelDiff.exe" %4 %5 ../udm/%6
IF %ERRORLEVEL%==0 GOTO CG 
echo * The output model %4 genereated by GRE.exe is not correct >>  "%GREAT_TEST_LOGF%"
set ERRORLEV=2

:CG
cd ..
"%GREAT_PATH%/bin/cg.exe" %7 %2 -e
IF %ERRORLEVEL%==0 GOTO End 
SET ERRORLEV=1
echo * The CG failed on %1 >>  "%GREAT_TEST_LOGF%"
GOTO End
 
:RunMasIntError
	echo *Run MasterInterpreter FAILED on %1 >>  "%GREAT_TEST_LOGF%"
	SET ERRORLEV=1 
	GOTO End
:RunGREError
	echo *Run GRE FAILED on %1 >>  "%GREAT_TEST_LOGF%"
	SET ERRORLEV=1 
	GOTO End
:ModelCheckError
	cd ..
	echo * The output model %4 genereated by GRE is not correct >>  "%GREAT_TEST_LOGF%"
	SET ERRORLEV=1
	GOTO End
:End