import os
import re
import glob
import os.path
import optparse
import subprocess
import unittest
from string import split
import sys
path = os.path.abspath(os.path.join(os.path.dirname(__file__), '../common-scripts'))
if not path in sys.path:
    sys.path.insert(1, path)
del path
import gme
import mgadiff
import xmlrunner


class testGReAT(unittest.TestCase):
    """def testGReATsamples(self):
    outputMGA=None
    correctMGA=None
    
    for file in glob.glob("%s\\*.xm[le]" % os.path.abspath(self.testdir)):
       if not re.search("-gr.xml", file,re.IGNORECASE):
          greatFile=file
          print "GReAT file is" + greatFile
          gme.xme2mga(greatFile)
          break
    
    print "Registering Meta's"
    for metaxme in glob.glob("%s\\Meta\\*.xm[le]" % os.path.abspath(self.testdir)):
       gme.xme2xmp(metaxme)
       gme.register_if_not_registered(os.path.splitext(metaxme)[0] + ".mga")
    
    
    #print "Getting & creating the input and 'correct output' models"
    for modelxme in glob.glob("%s\\Models\\*.xm[le]" % os.path.abspath(self.testdir)):
       if not re.search("correct", modelxme,re.IGNORECASE):
          print "Output modelxme "+modelxme
          gme.xme2mga(modelxme)
          outputMGA=os.path.splitext(modelxme)[0] + ".mga"
          print "Got output"
       else:
          print "Correct modelxme "+modelxme
          gme.xme2mga(modelxme)
          correctMGA=os.path.splitext(modelxme)[0] + ".mga"
          print "Got correct"
    
    #print outputMGA + "*** ***" +correctMGA
    
    #Once we have all the files, run the 3 interpreters
    print "Running the interpreters"
    self.runGReATinterpreters(greatFile)
    
    
    #With the final models created compare the two models
    print "Comparing"+outputMGA + "\n" +correctMGA
    assert mgadiff.compare(outputMGA, correctMGA)==True"""
    
    def testGReATsamples(self):
        files=[]
        print "\n!!!!!!!!!! Processing Directory %s !!!!!!!!!!" % self.testDir
        files=glob.glob("%s\\Meta\\*.xme" % self.testDir) or glob.glob("%s\\Meta\\*\\*.xme" % self.testDir)
        for metaxme in files:
            import win32com.client
            xme = win32com.client.DispatchEx("Mga.MgaParser")
            (paradigm, parversion, parguid, basename, ver) = xme.GetXMLInfo(metaxme)
            if paradigm != "MetaGME":
                continue
            gme.xme2xmp(metaxme)
        
        #if self.dir== "SignalFlow2FlatSF":
        greatFiles=[]
        inputFiles=[]
        outputFiles={}
        greatFiles=self.getGreatTransformations(self.testDir)
        for file in greatFiles:
            inputFiles, outputFiles =self.getFileNames( file)
            
            for inpFile in inputFiles:
                inputXME=os.path.splitext(inpFile)[0] + ".xme"
                gme.xme2mga(inputXME)
            
            self.runGReATinterpreters(file)
            for outFile in outputFiles.keys():
                outputXME=os.path.splitext(outputFiles[outFile])[0] + ".xme"
                if self.opts.gre:
                    # FIXME: need to run GRengine on each input file
                    print "Running GREngine on " + file
                    gme.run_interpreter("MGA.Interpreter.InvokeGRengine", file, param=128)
                    if re.search(".mga$", outFile, re.IGNORECASE):
                        gme.xme2mga(outputXME)
                        print "***********************compare(a.b)=************************\n"+outputFiles[outFile]+"\n"+outFile
                        gme.xme2mga(outputFiles[outFile])
                        self.assertTrue(mgadiff.compare(outputFiles[outFile], outFile))

                if self.opts.runcode:
                    print "RunCode"
                    fullFilePath = os.path.abspath(glob.glob("%s\\Gen\\*.vcproj" % self.testDir).pop())
                    projName = os.path.splitext(os.path.basename(fullFilePath))[0]

                    command = "devenv /Upgrade \"%s\" " % (fullFilePath)
                    if os.system(command):
                        self.fail(command + " failed")
                    command = "devenv \"%s\" /Rebuild \"Release\" /Project %s" % (fullFilePath,projName)
                    if os.system(command):
                        self.fail(command + " failed")
                    command = '"'+os.path.abspath(glob.glob("%s\\Gen\\Release\\%s.exe" % (self.testDir, projName)).pop())+'" '+ "-d"
                    # FIXME: need to run generated code on each input file
                    os.chdir(self.testDir)
                    if not os.system(command):
                        self.fail(command + " failed")
                    if re.search(".mga$", outFile, re.IGNORECASE):
                        gme.xme2mga(outputXME)
                        self.assertTrue(mgadiff.compare(outputFiles[outFile], outFile))

    def runGReATinterpreters(self,passedFile):
        gme.RunGreatMasterInt(passedFile)
        if self.opts.codegen:
            gme.run_interpreter("Generate code from rules", passedFile, param=128)

    def getFileNames(self,file):
        file = os.path.abspath(file)
        inputFiles=[]
        outputFiles={}
        with gme.Project.open(file) as project:
            configurations = (fco for fco in project.project.RootFolder.ChildFolders if fco.MetaBase.Name == "Configurations").next()
            configuration = (fco for fco in configurations.ChildFCOs if fco.MetaBase.Name == "Configuration").next()
            for fco in configuration.ChildFCOs:
                if fco.MetaBase.Name == "File":
                    for attr in fco.Attributes:
                        if re.search("input",attr.Value,re.IGNORECASE):
                            inputFiles.append("%s\%s" % (os.path.dirname(file), attr.Value))
                        elif re.search("output",attr.Value,re.IGNORECASE):
                            outputFiles["%s\%s" % (os.path.dirname(file), attr.Value)]=re.sub("output", "correct", "%s\%s" % (os.path.dirname(file), attr.Value))
        return inputFiles, outputFiles
   
    def getGreatTransformations(self,directory):
        directory=os.path.abspath(directory)
        array=[]
        
        for file in glob.glob("%s\\*.xme" % directory):
            gme.xme2mga(file)
            array.append(os.path.splitext(file)[0] + ".mga")
        return array


#def suite(opts = optparse.Values(),args=None,currDir=None,arrIntr=[]):
def suite(opts = optparse.Values(),dirs=None,currDir=None):
    if not currDir:
        currDir = os.path.dirname(__file__)
    if not dirs:
        dirs = filter(lambda f: os.path.isdir(f) and f != ".svn", glob.glob(os.path.join(currDir, "*")))
        dirs = map(lambda d: os.path.abspath(d), dirs)
    suite = unittest.TestSuite()
    for dir in dirs:
        #if dir =="GroupSample_1":
            test = testGReAT("testGReATsamples")
            test.testDir = dir
            test.opts = opts
            suite.addTest(test)
    return suite

if __name__ == "__main__":
    parser = optparse.OptionParser()
    parser.add_option("-x", "--xml", action="store_true", dest="xml")
    parser.add_option("-d", "--runcode", action="store_true", dest="runcode")
    parser.add_option("-c", "--nocodegen", action="store_false", dest="codegen", default=True)
    parser.add_option("-g", "--nogrengine", action="store_false", dest="gre", default=True)
    
    (options, args) = parser.parse_args()
    
    if options.xml:
        with open("tests.xml", "w") as output:
            output.write("<testsuites>")
            for test in suite(options, args, os.path.abspath("."))._tests:
                runner = xmlrunner.XMLTestRunner(output)
                runner.run(test)
            output.write("</testsuites>")
    else:
        runner = unittest.TextTestRunner()
        runner.run(suite(options, args, os.path.abspath(".")))
