#include "DistinguishedOutputSorter.h"
#include "PEStringTable.h"
#include "GReATUtils.h"

void DistinguishedOutputSorter::generate( Function& sorterFuncDef) {
	for( ParamDatas_t::const_iterator itOutputs= _ruleOutputs.begin(); itOutputs!= _ruleOutputs.end(); ++itOutputs) {
		const GR::ObjectWrapper& ow= itOutputs->_param;
		if ( ow.type() != GR::PatternObject::meta)
			continue;
		GR::PatternObject po= GR::PatternObject::Cast( ow);
		const std::string& CMPFUNC= po.cmpfunc();
		if ( CMPFUNC.empty()) {
			continue;
		}
//		std::string TYPE= ( std::string)ow.paradigmName() + RES + ( std::string)ow.classType();
		std::string TYPE= PE::getFullType(ow);
		std::string OUTPUT= itOutputs->_memberDef->_variable;
		const std::string& CASTER= "_caster";
		std::string NeitherPredicateName= PE::createUniqueName( "neitherPredicate"+ convertToCPlusPlusName( TYPE));
#if _MSC_VER < 1300
//		OUTPUT->sort( std::ptr_fun( CMPFUNC_of_TYPE));
		sorterFuncDef.add( *new Expression(  OUTPUT+ "->sort( std::ptr_fun( "+ generateCmpSpecName( CMPFUNC, TYPE)+ "))"));
//		NeitherPredicate< Udm::Object> neitherPredicateTYPE( std::ptr_fun( CMPFUNC_of_TYPE));
		sorterFuncDef.add( *new Expression( "NeitherPredicate< Udm::Object> "+ NeitherPredicateName+ "( std::ptr_fun( "+ generateCmpSpecName( CMPFUNC, TYPE)+ "))"));
#else
//		OUTPUT->sort( std::ptr_fun( CMPFUNC_caster< Udm::Object, TYPE));
		sorterFuncDef.add( *new Expression( OUTPUT+ "->sort( std::ptr_fun( "+ CMPFUNC+ CASTER+ "< Udm::Object, "+ TYPE+ ">))"));
//		NeitherPredicate< Udm::Object> neitherPredicateTYPE( std::ptr_fun( CMPFUNC_caster< Udm::Object, TYPE>));
		sorterFuncDef.add( *new Expression( "NeitherPredicate< Udm::Object> "+ NeitherPredicateName+ "( std::ptr_fun( "+ CMPFUNC+ CASTER+ "< Udm::Object, "+ TYPE+ ">))"));
#endif
//		OUTPUT->unique( neitherPredicateTYPE);
		sorterFuncDef.add( *new Expression( OUTPUT+ "->unique( "+NeitherPredicateName +")"));
	}
}