/* NAME:	Output sorter
 * AUTHOR:	Attila Vizhanyo - viza@isis-server.isis.vanderbilt.edu
 *
 * Generate code, which sorts all the output containers independently
 * and removes subsequent equal elements.
 */
#ifndef __DISTINGUISHEDOUTPUTSORTER_H
#define __DISTINGUISHEDOUTPUTSORTER_H

#ifdef _MSC_VER
#pragma warning (disable : 4786)
#pragma warning (disable : 4503) 
#endif

#include <map>
#include "RuleTypes.h"
#include "PE.h"
#include "PacketPassing.h"

// This class is not designed to be a base class. 
// Either don't inherit from it, or add virtual destructor.
class DistinguishedOutputSorter
{
public:
	// ctor; see parameter desc. at the member variables declaration part. 
	DistinguishedOutputSorter( const GRSimpleRule& rule, 
		const ParamDatas_t& ruleOutputs
		) : _rule( rule) , _ruleOutputs( ruleOutputs)
		{}
	void generate( Function& sorterFuncDef);

protected:

private:
	// Rule, on which output sorter code generation executes.
	GRSimpleRule _rule;
	// 
	const ParamDatas_t& _ruleOutputs;
};

#endif //__DISTINGUISHEDOUTPUTSORTER_H