#if !defined(EventQueue_h)
#define EventQueue_h

#include <boost/thread/mutex.hpp>
#include <boost/thread/condition.hpp>
#include <list>


#include "../GRDebugInterface/GRDebugEvent.h"
#include "IGRDFrontEnd.h"

typedef std::list<GRDI::EventSet> EventQueueImp;

namespace GRDI
{

typedef boost::mutex::scoped_lock Lock;

class EventQueue
{
  EventQueueImp m_queue;

  boost::condition    m_not_full;
  boost::condition    m_not_empty;

  boost::mutex        m_mutex; 

  unsigned int m_maxSize;

public:

  EventQueue(int maxSize);

  void insert(EventSet event);
  EventSet remove();

};

};

#endif