#include <boost/thread/thread.hpp>
#include "GRDFrontEndFactory.h"
#include "GRDFrontEnd.h"

namespace GRDI
{
IGRDFrontEnd* GRDFrontEndFactory::create()
{
  return new GRDI::GRDFrontEnd();
}
boost::thread* GRDFrontEndFactory::m_thrd = 0;
struct FrontEndThread
{
  IGRDFrontEnd*  m_api;
  
  FrontEndThread(IGRDFrontEnd*  api) : m_api(api){}
  void operator()()
  {
    m_api->run();
  }
};

IGRDFrontEnd* GRDFrontEndFactory::create_new_thread()
{
  FrontEndThread fe(new GRDI::GRDFrontEnd());

  GRDFrontEndFactory::m_thrd = new boost::thread(fe);

  return fe.m_api;
}

//=====================================
void GRDFrontEndFactory::join()
{
  if (GRDFrontEndFactory::m_thrd)
  {
    GRDFrontEndFactory::m_thrd->join(); 
    delete GRDFrontEndFactory::m_thrd, GRDFrontEndFactory::m_thrd = 0;
  }
}

};//namespace GRDI