/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/


// UdmApp.cpp: implementation of the CUdmApp class.
// This file was automatically generated as UdmApp.cpp
// by UDM Interpreter Wizard on Monday, May 13, 2002 13:45:42

// Tihamr Levendovszky 05-13-02

#include "stdafx.h"
#include <afxdlgs.h> // For CFileDialog
#include "resource.h"

//#include <iostream.h>
#include <atlbase.h>
#include <comdef.h>

#include <time.h>
#include "UdmStatic.h"
#include "UdmDom.h"
#include "UdmGME.h"
#include "UmlExt.h"
#include "UdmUtil.h"

#include "UdmApp.h"
#include "UdmConfig.h"

#include "resource.h"

#include <direct.h>
#include <process.h>

//#include "GReATConfig.h"
#include "GReATConfigMeta.h"
#include "GReATUtils.h"
#include<fstream>
#include <comhelp.h>
#include"GMECOM.H"
#include "BgWindow.h"
#include <fstream>

extern void dummy(void); // Dummy function for UDM meta initialization

typedef long uniqueId_type;

using UdmGme::UdmId2GmeId;


char* GetRelativeFilename(const char *currentDirectory,const char *absoluteFilename);
bool isSameDrive(const char *currentDirectory,const char *absoluteFilename);


/*class InterpDialog : public CDialog
{
	DECLARE_DYNAMIC(InterpDialog)

public:
	InterpDialog(CWnd* pParent /*=NULL)
	: CDialog(InterpDialog::IDD, pParent){
	}
	virtual ~InterpDialog();

// Dialog Data
	enum { IDD = IDD_DIALOG1 };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
};*/
std::string convertPath(const std::string &currentPath, const std::string &absoluteFilename)
{
	std::string path(absoluteFilename);
	if(!absoluteFilename.empty() && 
		isSameDrive(currentPath.c_str(), absoluteFilename.c_str()))
		path = (std::string)(GetRelativeFilename(currentPath.c_str(),absoluteFilename.c_str()));

	return path;
}

static std::string currPath = "";
/*********************************************************************************/
/* Initialization function. The framework calls it before preparing the backend. */
/* Initialize here the settings in the config static object.					 */
/* Return 0 if successful.														 */
/*********************************************************************************/
int CUdmApp::Initialize()
{
	// TODO: Your initialization code comes here...
	return 0;
}

/* 
Remarks to CUdmApp::UdmMain(...):
0.	The p_backend points to an already open backend, and the framework 
	closes it automatically. DO NOT OPEN OR CLOSE IT!
	To commit changes use p_backend->CommitEditSequence().
	To abort changes use p_backend->AbortEditSequence().
	To save changes to a different file use p_backend->SaveAs() or p_backend->CloseAs().

1.	Focus is the currently open model.

2.	The possible values for param (from GME DecoratorLib.h component_startmode_enum):
	GME_MAIN_START			=   0,
	GME_BROWSER_START		=   1,
	GME_CONTEXT_START		=   2,
	GME_EMBEDDED_START		=   3,
	GME_MENU_START			=  16,
	GME_BGCONTEXT_START		=  18,
	GME_ICON_START			=  32,
	METAMODEL_CHECK_SYNTAX	= 101

 3. The framework catches all the exceptions and reports the error in a message box,
	clean up and close the transactions aborting the changes. You can override this 
	behavior by catching udm_exception. Use udm_exception::what() to form an error 
	message.
*/

/***********************************************/
/* Main entry point for Udm-based Interpreter  */
/***********************************************/
//CGREngineDlgDlg* CUdmApp::m_pDialog = 0;

CString CUdmApp::mgaPath = "";


void CUdmApp::UdmMain(
					 Udm::DataNetwork* p_backend,		// Backend pointer(already open!)
					 Udm::Object focusObject,			// Focus object
					 std::set<Udm::Object> selectedObjects,	// Selected objects
					 long param,						// Parameters
					 CComPtr<IGMEOLEApp> gme,
					 IMgaProject *project
					 )
{	
	using namespace std;
		UMLModelTransformer::RootFolder rf = UMLModelTransformer::RootFolder::Cast(p_backend->GetRootObject());
		const set<UMLModelTransformer::Configurations> &cfgs = rf.Configurations_kind_children();
		if(cfgs.empty()) throw udm_exception("No Configurations found.");

		const UMLModelTransformer::Configurations &cfg = *(cfgs.begin());		
		const set<UMLModelTransformer::Configuration> &cfgfiles = cfg.Configuration_kind_children();
		if(cfgs.empty()) throw udm_exception("No Configuration found.");

		UMLModelTransformer::Configuration cfgfile = *(cfgfiles.begin());

//Get the full path from the greate_cfg
    const std::string& greate_cfg = getFullPath((string)mgaPath, (string)cfgfile.ConfigFile());

   /* Set up parameters to be sent: */
   long BUFSIZE = 500;
   TCHAR tchBuf[500]; 
   std::string grdPath;
   if (!GetEnvironmentVariable("GREAT_PATH",tchBuf, BUFSIZE))
	   throw udm_exception("Variable GREAT_PATH is not defined.");
	grdPath = CString(tchBuf);
	grdPath +=  "\\bin"
#if _MSC_VER == 1600
	""
#elif _MSC_VER == 1500
	"_vs9"
#else
#error Unrecognized _MSC_VER
#endif
	"\\grd"
#ifdef _DEBUG
	"_d"
#endif
	".exe";


///Change for "Rule viewing" in GME
	BgWindow bgw;
	bgw.Create(IDD_DIALOG1,NULL);
	std::stringstream ss;
	int handle = (int)(void*)bgw.GetSafeHwnd();
	ss<<handle;
///Change for "Rule viewing" in GME



	std::string makeCall =  "\"" + grdPath + "\"";
	makeCall +=  " \"" + greate_cfg + "|" + ss.str() + "\""  ;	///Updated by Akash 

	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	ZeroMemory( &si, sizeof(si) );
	si.cb = sizeof(si);
	ZeroMemory( &pi, sizeof(pi) );

    // Start the child process. 
    if( !CreateProcess( NULL, // No module name (use command line). 
        const_cast<LPSTR>(makeCall.c_str()) , // Command line. 
        NULL,             // Process handle not inheritable. 
        NULL,             // Thread handle not inheritable. 
        FALSE,            // Set handle inheritance to FALSE. 
        0,                // No creation flags. 
        NULL,             // Use parent's environment block. 
        NULL,             // Use parent's starting directory. 
        &si,              // Pointer to STARTUPINFO structure.
        &pi )             // Pointer to PROCESS_INFORMATION structure.
    ) 
    {
		std::string error = "grd createProcess failed";

		LPTSTR errorText = NULL;
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPTSTR)&errorText, 0, NULL);

		if (NULL != errorText) {
			error += ": ";
			error += errorText;
			LocalFree(errorText);
		}

		throw udm_exception(error);
    }

    // Wait until child process exits.
	 ///Commented to get the control back to the interpreter
    //WaitForSingleObject( pi.hProcess, INFINITE );
    CloseHandle( pi.hProcess );
    CloseHandle( pi.hThread );
	// Close process and thread handles.

	p_backend->CloseWithUpdate();
	MSG msg;
	while (GetMessage(&msg, NULL, 0,0)){
		if(msg.message == WM_USER + 48){
			bstr_t out = UdmId2GmeId(msg.wParam).c_str();
			CComPtr<IMgaFCO> _fco;
			try{
				UdmGme::GmeDataNetwork dngBackend(META_NAMESPACE::diagram);
				try{
					dngBackend.OpenExisting(project, Udm::CHANGES_LOST_DEFAULT);
				}
				catch(udm_exception& e){
					// It may happen that the user closes GME without closing the debugger. Opening the MGA project will then fail
					bgw.DestroyWindow();
					break;
				}
				COMCHECK2(project, project->GetFCOByID(out,&_fco));
				dngBackend.CloseWithUpdate();
				COMCHECK2(gme, gme->ShowFCO(_fco));
			}
			catch(BON::Exception& exc){
				throw udm_exception(exc.getErrorMessage());
			}
		}
		else if(msg.message == WM_USER + 57){
				break;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	gme->ConsoleMessage(L"Debugger Closed",MSG_NORMAL);
}

