// UdmApp.h: interface for the CUdmApp class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_UDMAPP_H__296A93EB_6DB6_4179_AA0B_A3D799FB3A1C__INCLUDED_)
#define AFX_UDMAPP_H__296A93EB_6DB6_4179_AA0B_A3D799FB3A1C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Udm includes
#include "UdmBase.h"
#include "Uml.h"
#include "UmlExt.h"

#ifdef _USE_DOM
	#include "UdmDOM.h"
#endif

#include "UdmGme.h"
#include "UdmStatic.h"

#include "UMLModelTransformer.h"
#include "BON.h"
#include "BONImpl.h"

class ConfigInfo
{
public:
	ConfigInfo() {};
	ConfigInfo(std::string id, std::string meta, std::string mode):fileId(id),metaName(meta),fileMode(mode){};
	std::string fileId;
	std::string metaName;
	std::string fileMode;
	std::string filePath;
	std::string copyPath;
};

class CUdmApp  
{
public:
	static int Initialize();
	static CString mgaPath;
	static void UdmMain(Udm::DataNetwork* p_backend,Udm::Object currentObject, std::set<Udm::Object> selectedObjects, long param,CComPtr< IGMEOLEApp > gme,IMgaProject *project);
	CComPtr<IGMEOLEApp> _gme;
	CComPtr<IMgaProject> _project;

protected:
	static void getInitialCfgInfos(const std::string &greate_cfg, 
								 UMLModelTransformer::Configuration &cfgfile,
								 std::vector<ConfigInfo> &cfgInfos);
};

#endif // !defined(AFX_UDMAPP_H__296A93EB_6DB6_4179_AA0B_A3D799FB3A1C__INCLUDED_)
