// AttributeClass.cpp : implementation file
//

#include "stdafx.h"
#include "GRDebuggerGUI.h"
#include "AttributeClass.h"


// AttributeClass dialog


IMPLEMENT_DYNAMIC(AttributeClass, CDialog)

AttributeClass::AttributeClass(CWnd* pParent /*=NULL*/)
	: CDialog(AttributeClass::IDD, pParent)
{

}

namespace {
std::string UdmId2GmeId(long udmId)
{
		char buffer[24];
		sprintf_s(buffer, "id-%04X-%08X", udmId / 100000000 + 100, udmId % 100000000);
		return std::string(buffer);
}
}



AttributeClass::AttributeClass(Udm::Object &p_UO, int i)
	: m_UO(p_UO),
	CDialog(AttributeClass::IDD)
{
	
}
BOOL AttributeClass::OnInitDialog(){
	CDialog::OnInitDialog();
	m_List.SetExtendedStyle(LVS_EX_GRIDLINES);
	

	LVCOLUMN lvColumn;

	lvColumn.mask = LVCF_FMT | LVCF_TEXT | LVCF_WIDTH;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = 100;
	lvColumn.pszText = "Property";
	m_List.InsertColumn(0, &lvColumn);

	lvColumn.mask = LVCF_FMT | LVCF_TEXT | LVCF_WIDTH;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = 250;
	lvColumn.pszText = "Value";
	m_List.InsertColumn(1, &lvColumn);


	LVITEM lvItem;
	int nItem;

	/*lvItem.mask = LVIF_TEXT;
	lvItem.iItem = 1;
	lvItem.iSubItem = 0;
	lvItem.pszText = "Name";
	nItem = m_List.InsertItem(&lvItem);

	BOOL val = m_List.SetItemText(nItem, 1, UdmUtil::ExtractName(m_UO).c_str());*/

	lvItem.mask = LVIF_TEXT;
	lvItem.iItem = 1;
	lvItem.iSubItem = 0;
	lvItem.pszText = "ObjectID";
	nItem = m_List.InsertItem(&lvItem);

	m_List.SetItemText(nItem, 1,UdmId2GmeId(m_UO.uniqueId()).c_str());


	lvItem.mask = LVIF_TEXT;
	lvItem.iItem = 2;
	lvItem.iSubItem = 0;
	lvItem.pszText = "Path";
	nItem = m_List.InsertItem(&lvItem);

	m_List.SetItemText(nItem, 1, m_UO.getPath().c_str());

	Uml::Class cls = m_UO.type();
	std::set<Uml::Attribute> Attrib = cls.attributes();
	std::set<Uml::Attribute> ancAttrib = Uml::AncestorAttributes(cls);
	
	Attrib.insert(ancAttrib.begin(), ancAttrib.end());
	std::stringstream ss;
	int ctr = 2;
	for(std::set<Uml::Attribute>::iterator ai = Attrib.begin(); ai != Attrib.end(); ++ai){
		ss << ai->name();

		lvItem.mask = LVIF_TEXT;
		lvItem.iItem = ++ctr;
		lvItem.iSubItem = 0;
		lvItem.pszText = _strdup(ss.str().c_str()); 
		nItem = m_List.InsertItem(&lvItem);

		ss.str("");
		//ss.clear();
		
//		ss << m_UO.getStringAttr(*ai);

		std::string attrType = ai->type();
		int max = ai->max();
		if (attrType == "String") {
			ss << m_UO.getStringAttr(*ai);
		}
		else if (attrType == "Boolean") {
			ss << m_UO.getBooleanAttr(*ai);
		}
		else if (attrType == "Real") {
			ss << m_UO.getRealAttr(*ai);
		}
		else if (attrType == "Integer") {
			ss << m_UO.getIntegerAttr(*ai);
			/*if (max == 1)
				
			else {
			}*/
		}
		m_List.SetItemText(nItem, 1, ss.str().c_str());
		ss.str("");
		//ss.clear();
	}
	return TRUE;
}
AttributeClass::~AttributeClass()
{
}

void AttributeClass::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_List);
}


BEGIN_MESSAGE_MAP(AttributeClass, CDialog)
	ON_BN_CLICKED(IDOK, &AttributeClass::OnBnClickedOk)
END_MESSAGE_MAP()


// AttributeClass message handlers

void AttributeClass::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	//::PostMessage(NULL,WM_USER + 99, -1, 0);
	OnOK();
}
