// GRDebuggerGUI.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "GRDebuggerGUI.h"
#include <io.h>
#include <fcntl.h>
#include <conio.h>

#include <fstream>
#include "MainFrm.h"

#include "GRDebuggerGUIDoc.h"
#include "GRDebuggerGUIView.h"
#include "SourceViewFrame.h"
#include "Messages.h"
#include "GReATVersion.h"
#include "../GRDebuggerConsole/GRDebuggerConsolFactory.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CGRDebuggerGUIApp

BEGIN_MESSAGE_MAP(CGRDebuggerGUIApp, CWinApp)
	//{{AFX_MSG_MAP(CGRDebuggerGUIApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_HELP_TEXT, OnHelp)

		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGRDebuggerGUIApp construction

CGRDebuggerGUIApp::CGRDebuggerGUIApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CGRDebuggerGUIApp object

CGRDebuggerGUIApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CGRDebuggerGUIApp initialization

//=====================================
void  CGRDebuggerGUIApp::ConsoleExit()
{
  m_launcher->stop();
}

BOOL WINAPI ConsoleHandler(DWORD CEvent)
{
  bool exit = false;
  switch(CEvent)
  {
    case CTRL_C_EVENT: exit = true; break;
    case CTRL_BREAK_EVENT: exit = true; break;
    case CTRL_CLOSE_EVENT: exit = true; break;
  }

  if (exit)
  {
    theApp.ConsoleExit();        
    return TRUE;
  }
  return FALSE;
}

BOOL IsFileExist(LPCSTR lpszFilename)
{
	WIN32_FIND_DATA wfd;

	HANDLE hFind = FindFirstFile(lpszFilename, &wfd);
	if (hFind == INVALID_HANDLE_VALUE)
		return FALSE;
	else
	{
		FindClose(hFind);
		return TRUE;
	}
}

BOOL CGRDebuggerGUIApp::InitInstance()
{
  
  m_launcher = 0;
  m_debuggerConsol = 0;
  CWzdCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

  if (cmdInfo.m_wrongPar)
  {
    AfxMessageBox(GRLauncher::m_usageTxt.c_str() );
    exit(-1);
  }

  if (!cmdInfo.m_debug || cmdInfo.m_consol)
  {

      AllocConsole();
      int houtCrt = 0;  
      FILE *houtf = NULL;
      houtCrt = _open_osfhandle((long) GetStdHandle(STD_OUTPUT_HANDLE), _O_TEXT);
      houtf = _fdopen( houtCrt , "w" );
      *stdout = *houtf;
      setvbuf( stdout, NULL, _IONBF, 0 );

      int hinCrt = 0;  
      FILE *hinf = NULL;

      hinCrt = _open_osfhandle((long) GetStdHandle(STD_INPUT_HANDLE), _O_TEXT);
      hinf = _fdopen( hinCrt, "r" );
      *stdin = *hinf;
      setvbuf( stdin, NULL, _IONBF, 0 );


      std::ios::sync_with_stdio();
      if (SetConsoleCtrlHandler(
          (PHANDLER_ROUTINE)ConsoleHandler,TRUE)==FALSE)
      {
          // unable to install handler... 
          // display message to the user
          printf("Unable to install handler!\n");
          return -1;
      }
     //SetConsoleCtrlHandler(NULL, TRUE);


      int argc = 2;
      const char* argv[] = {"", "", "-c"};

      if (cmdInfo.m_strFileName.GetLength( )!= 0)
      {
        
        if (IsFileExist((LPCSTR) cmdInfo.m_strFileName))
         argv[1] = (LPCSTR) cmdInfo.m_strFileName;
        else
        {
          CString err(cmdInfo.m_strFileName);
            err += " file does not exist";
          AfxMessageBox(err);
        }
      }

      if (cmdInfo.m_consol)
      {
        argc = 3;
      }


      m_launcher = new GRLauncher();
      if (m_launcher->setPars(argc, argv))
      {
        std::cout << "Loading..." << std::endl;

        m_debuggerConsol = 0;  
        if (cmdInfo.m_consol)
          m_debuggerConsol = GRDebuggerConsolFactory::create_new_thread();
        m_launcher->init(m_debuggerConsol);
        m_launcher->run();
        m_launcher->close();
        if (m_debuggerConsol)
        {
          GRDebuggerConsolFactory::join(); 
          delete m_debuggerConsol, m_debuggerConsol = 0 ;
        }
      }
      if (m_launcher)
         delete m_launcher, m_launcher =0;
      printf( "Press any key to exit ...\n" );
      _getch();
      FreeConsole();

  }
  else
  {

	  AfxEnableControlContainer();

	  // Standard initialization
	  // If you are not using these features and wish to reduce the size
	  //  of your final executable, you should remove from the following
	  //  the specific initialization routines you do not need.

  #ifdef _AFXDLL
	  Enable3dControls();			// Call this when using MFC in a shared DLL
  #else
	  Enable3dControlsStatic();	// Call this when linking to MFC statically
  #endif

	  // Change the registry key under which our settings are stored.
	  // TODO: You should modify this string to be something appropriate
	  // such as the name of your company or organization.
	  SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	  LoadStdProfileSettings();  // Load standard INI file options (including MRU)


	  AddDocTemplate(new CSingleDocTemplate(IDR_MAINFRAME,
 		  RUNTIME_CLASS(CGRDebuggerGUIDoc),
 		  RUNTIME_CLASS(CMainFrame), 
 		  RUNTIME_CLASS(SourceTxtView)));

    OnFileNew();
	  // Parse command line for standard shell commands, DDE, file open
  //x	CCommandLineInfo cmdInfo;
  //x	ParseCommandLine(cmdInfo);

    if (cmdInfo.m_strFileName.GetLength( ) != 0 )
    {
		 ///Updated by Akash ///Change for "Rule viewing" in GME
		 std::string temp((LPCSTR)cmdInfo.m_strFileName);
		 std::string::const_iterator pos = std::find( temp.begin(),temp.end(),'|');
		 if(pos == temp.end()){
			std::string handle("");
			m_windowHandle = handle;
		 }
		 else{
			 std::string handle(pos+1 , temp.end());
			 m_windowHandle = handle;
		 }
		 std::string file(temp.begin(), pos);
		 cmdInfo.m_strFileName = file.c_str();
		 ///Updated by Akash ///Change for "Rule viewing" in GME

      if (!IsFileExist((LPCSTR) cmdInfo.m_strFileName))
      {
        CString err(cmdInfo.m_strFileName);
        err += " file does not exist";
        AfxMessageBox(err);
        return FALSE;
      }

   	  if (!ProcessShellCommand(cmdInfo))
 	  	  return FALSE;
    }
 
    m_pMainWnd->ShowWindow(SW_SHOW);
    m_pMainWnd->UpdateWindow();
  }  
  
  return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CGRDebuggerGUIApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CGRDebuggerGUIApp::OnHelp()
{
	long BUFSIZE = 500;
   TCHAR tchBuf[500]; 
   std::string grdPath;
	grdPath = "hh.exe ";
   if (GetEnvironmentVariable("GREAT_PATH",tchBuf, BUFSIZE)){
		grdPath += CString(tchBuf);
		grdPath += "\\Doc\\GRDebugHelp.chm";
	}
	
	
	
	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	ZeroMemory( &si, sizeof(si) );
	si.cb = sizeof(si);
	ZeroMemory( &pi, sizeof(pi) );

	CreateProcessA( NULL, // No module name (use command line). 
        "notepad.exe" , // Command line. 
        NULL,             // Process handle not inheritable. 
        NULL,             // Thread handle not inheritable. 
        FALSE,            // Set handle inheritance to FALSE. 
        0,                // No creation flags. 
        NULL,             // Use parent's environment block. 
        NULL,             // Use parent's starting directory. 
        &si,              // Pointer to STARTUPINFO structure.
        &pi );             // Pointer to PROCESS_INFORMATION structure.
    

}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
  CString ver("GReAT Debugger v.1.0  [engine v.");
  ver += CString(GREAT_VERSION) + CString("]"); 
  SetDlgItemText(IDC_VERSION,ver);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

///////////////////////////////////////////////////////////////
// CWzdCommandLineInfo

CWzdCommandLineInfo::CWzdCommandLineInfo():
    m_debug (true),
    m_consol (false),
    m_wrongPar(false)
{
}

CWzdCommandLineInfo::~CWzdCommandLineInfo()
{
}

///////////////////////////////////////////////////////////////
void CWzdCommandLineInfo::ParseParam(const TCHAR* pszParam, BOOL bFlag,
    BOOL bLast)
{
    CString sArg(pszParam);
    if (bFlag)
    {
       if(sArg.CompareNoCase("d") == 0)
       {
          m_debug = true;
       }
       else
       if(sArg.CompareNoCase("c")== 0)
       {
          m_consol = true;
          m_debug  = true;
       }
       else
       if (sArg.CompareNoCase("nd")== 0)
       {
        m_debug = false;
       }
       else
       {
         m_wrongPar = true;
       }
    }
    
    CCommandLineInfo::ParseParam(pszParam,bFlag,bLast);
}
/////////////////////////////////////////////////////////////////////////////
// CGRDebuggerGUIApp message handlers


int CGRDebuggerGUIApp::ExitInstance(){
	///Updated by Akash ///Change for "Rule viewing" in GME

	if (m_windowHandle != "") {
		HWND handle = 0;
		if (sscanf(m_windowHandle.c_str(), "%d", (int)(void*)&handle) == 1) {
			PostMessageA(handle, WM_USER + 57, 0, 0);
		}
	}

	return CWinApp::ExitInstance();
}

