#if !defined(AFX_STACKVIEW_H__B4FAC5F7_BFB2_4836_98A8_4ED3958F09F9__INCLUDED_)
#define AFX_STACKVIEW_H__B4FAC5F7_BFB2_4836_98A8_4ED3958F09F9__INCLUDED_

#include <map>
#include <string>
#include "../GRDebugInterface/GRDebugTypes.h"
#include "SourceTxtView.h"
#include "AttributeClass.h"
#include<udmbase.h>
#include <UdmUtil.h>
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// StackView.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// StackView view

typedef std::map<GRDI::ContextID, HTREEITEM> IdItemMap;
typedef std::map<GRDI::IVariablePtr, HTREEITEM> VariablePtrItemMap;
typedef std::map<HTREEITEM, Udm::Object> ItemObjectMap;
class CGRDebuggerGUIDoc;
class StackView : public CTreeView
{
protected:
	StackView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(StackView)

protected:
  IdItemMap   m_idMap;
  ItemLocIDMap      m_itemMap;

  VariablePtrItemMap m_varMap;
public:
  GRDI::LocationID  m_showLocID ;
  //CListCtrl *m_list;	///Added
  ItemObjectMap	m_itemObj;			///Added
  HTREEITEM m_RtClkTreeItem;			///Added
  CGRDebuggerGUIDoc *parent;
// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(StackView)
	public:
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL
protected:
void expandStackRecUp(HTREEITEM hmyItem );
void expandStackRecDown(HTREEITEM hmyItem );

public:
  void collapse(const GRDI::ContextID& id);
  void deleteContext(const GRDI::ContextID& id);
  void addCtx(const GRDI::ContextDescr& contextDescr);
  void clear();
  void expandStack();
  void showEmptyText();
  void showVar(const GRDI::IVariablePtr& var);
// Implementation
protected:
	virtual ~StackView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(StackView)
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnViewAttributes();	///Added
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STACKVIEW_H__B4FAC5F7_BFB2_4836_98A8_4ED3958F09F9__INCLUDED_)
