// UdmApp.h: interface for the CUdmApp class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_UDMAPP_H__296A93EB_6DB6_4179_AA0B_A3D799FB3A1C__INCLUDED_)
#define AFX_UDMAPP_H__296A93EB_6DB6_4179_AA0B_A3D799FB3A1C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "UMLModelTransformer.h"

// Udm includes
#include "UdmBase.h"
#include "Uml.h"
#include "UmlExt.h"

#ifdef _USE_DOM
	#include "UdmDOM.h"
#endif

#include "UdmGme.h"
#include "UdmStatic.h"

#include "IGReAT.h"
#include "GReAT.h"
#include "GReATFactory.h"
#include "GReATConfig.h"
#include "GReATConfigMeta.h"
#include "IGReATParameters.h"
#include "GReATParametersFactory.h"




class ConfigInfo
{
public:
	ConfigInfo() {};
	ConfigInfo(string id, string meta, string mode):fileId(id),metaName(meta),fileMode(mode){};
	string fileId;
	string metaName;
	string fileMode;
	string filePath;
	string copyPath;
};

class CUdmApp  
{
public:
	static int Initialize();
	static void UdmMain(Udm::DataNetwork* p_backend,Udm::Object currentObject, std::set<Udm::Object> selectedObjects, long param);
	static CString mgaPath;

protected:
	static void getInitialCfgInfos(const string &greate_cfg, 
								 UMLModelTransformer::Configuration &cfgfile,
								 vector<ConfigInfo> &cfgInfos);
	static bool updateConfigFile(UMLModelTransformer::Configuration &cfgfile,
								 vector<ConfigInfo> &cfgInfos);
	static CString workingPath;
};

#endif // !defined(AFX_UDMAPP_H__296A93EB_6DB6_4179_AA0B_A3D799FB3A1C__INCLUDED_)
