// LegacyUpdateVisitor.h: interface for the LegacyUpdateVisitor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LEGACYUPDATEVISITOR_H__F9896994_9803_423C_BA6B_8EB30AA0A5DA__INCLUDED_)
#define AFX_LEGACYUPDATEVISITOR_H__F9896994_9803_423C_BA6B_8EB30AA0A5DA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MetaGME.h"
#include "algorithm"

struct stringicmp; 

typedef std::map<std::string, std::string, stringicmp> strmap;

using namespace MetaGME;

class LegacyUpdateVisitor : public Visitor  
{
public:
	LegacyUpdateVisitor();
	virtual ~LegacyUpdateVisitor();

	void Visit_RootFolder(const RootFolder&);

	void Visit_SheetFolder(const SheetFolder&);
	void Visit_ParadigmSheet(const ParadigmSheet&);
	
	void Visit_Connection(const Connection&);
	void Visit_Reference(const Reference&);
	void Visit_Set(const Set&);

protected:
	void ConverGeneralPreferenceToMap(std::string pref, strmap &prefmap);
	std::string GetValueForName(std::string name, strmap &prefmap);

};

struct stringicmp 
{
  bool operator()(const std::string& first, const std::string& second) const;
};

// From website http://www.thecodezone.com/diary/archives/000057.html
class StringTokenizer : public std::vector<std::string>
{
	public:
		StringTokenizer(const std::string &rStr, const std::string &rDelimiters = " ,\n");

};

#endif // !defined(AFX_LEGACYUPDATEVISITOR_H__F9896994_9803_423C_BA6B_8EB30AA0A5DA__INCLUDED_)
