// UdmApp.cpp: implementation of the CUdmApp class.
// This file was automatically generated as UdmApp.cpp
// by UDM Interpreter Wizard on Monday, September 25, 2006 15:23:26



#include "stdafx.h"
#include "UdmApp.h"
#include "UdmConfig.h"
#include "Uml.h"
#include "CompareFunction.h"
#include <set>
#include <algorithm>
#include <utility>
#include <map>
#include <list>

using namespace std;

typedef map<UMLModelTransformer::In, UMLModelTransformer::Out> IOMap;
typedef map<UMLModelTransformer::In, UMLModelTransformer::In> IIMap;
typedef map<UMLModelTransformer::Out, UMLModelTransformer::Out> OOMap;

void CreateInputPorts(UMLModelTransformer::Expression &blank, Udm::Object& oold, UMLModelTransformer::Expression focusObj, IIMap &iMap);
void CreateOutputPorts(UMLModelTransformer::Expression &blank, Udm::Object& oold, UMLModelTransformer::Expression focusObj, OOMap &oMap);
void FillMap(IOMap &portMap, list<Udm::Object> objs);
template<typename T> void CreateConnections(T inMap, UMLModelTransformer::Block &nBlock);

/*********************************************************************************/
/* Initialization function. The framework calls it before preparing the backend. */
/* Initialize here the settings in the config global object.					  */
/* Return 0 if successful.														  */
/*********************************************************************************/
int CUdmApp::Initialize()
{

	// TODO: Your initialization code comes here...
	return 0;
}

UMLModelTransformer::Expression GetExpression(const Udm::Object& exprOrRef) {
	if (exprOrRef.type() == UMLModelTransformer::ExpressionRef::meta) {
		return UMLModelTransformer::ExpressionRef::Cast(exprOrRef).ref();
	} else {
		return UMLModelTransformer::Expression::Cast(exprOrRef);
	}
}


/* 
Remarks to CUdmApp::UdmMain(...):
0.	The p_backend points to an already open backend, and the framework 
	closes it automatically. DO NOT OPEN OR CLOSE IT!
	To commit changes use p_backend->CommitEditSequence().
	To abort changes use p_backend->AbortEditSequence().
	To save changes to a different file use p_backend->SaveAs() or p_backend->CloseAs().

1.	Focus is the currently open model.

2.	The possible values for param (from GME DecoratorLib.h component_startmode_enum):
	GME_MAIN_START			=   0,
	GME_BROWSER_START		=   1,
	GME_CONTEXT_START		=   2,
	GME_EMBEDDED_START		=   3,
	GME_MENU_START			=  16,
	GME_BGCONTEXT_START		=  18,
	GME_ICON_START			=  32,
	METAMODEL_CHECK_SYNTAX	= 101

 3. The framework catches all the exceptions and reports the error in a message box,
	clean up and close the transactions aborting the changes. You can override this 
	behavior by catching udm_exception. Use udm_exception::what() to form an error 
	message.
*/

/***********************************************/
/* Main entry point for Udm-based Interpreter  */
/***********************************************/

bool lessLength (const string& s1, const string& s2)
{
       return s1.length() < s2.length();
}

void CUdmApp::UdmMain(
					 Udm::DataNetwork* p_backend,		// Backend pointer(already open!)
					 Udm::Object focusObject,			// Focus object
					 set<Udm::Object> selectedObjects,	// Selected objects
					 long param)						// Parameters
{	

	/* First check to make sure all passed in objects are of type Expression */

	if(selectedObjects.empty())
	{
		AfxMessageBox("Please select at least one object.");
		return;
	}

	if(!(Uml::IsDerivedFrom(focusObject.type(), UMLModelTransformer::Expression::meta)))
	{
		AfxMessageBox("Focus object is not derived from Expression!");
		return;
	}

	for(set<Udm::Object>::iterator it = selectedObjects.begin();it != selectedObjects.end(); ++it)
	{
		if(!(Uml::IsDerivedFrom(focusObject.type(), UMLModelTransformer::Expression::meta)))
		{
			AfxMessageBox("Focus object is not derived from Expression!");
			return;
		}

	}

	/* Use a list of objects so that it's easier to sort */

	list<Udm::Object> selObjs(selectedObjects.begin(), selectedObjects.end());  //selObjs now has the sorted objects
	selObjs.sort(ptr_fun(XPosCmp_caster<Udm::Object, UMLModelTransformer::MgaObject>));

	/* These maps keep track of the ports that we need to connect; the GME backend doesn't allow invalid connections, so 
	   we must first discover the connections, keep track of them in the maps, move the objects, and then use the maps to 
	   reconnect the ports */

	IOMap portMap;   /* For connecting output ports to input ports */
	IIMap inputMap;  /* Input ports to input ports */
	OOMap outputMap; /* output ports to output ports */

    FillMap(portMap, selObjs);  //set up all port object maps

	UMLModelTransformer::Expression focusExpr = UMLModelTransformer::Expression::Cast(focusObject);
	UMLModelTransformer::Block nBlock = UMLModelTransformer::Block::Create(focusExpr);  /* The new block into which we insert the selected objs */
	// FIXME: this doesn't work if selObjs.front() is a ExpressionRef: it sets the position in the Template aspect only
	nBlock.position() = (UMLModelTransformer::MgaObject::Cast(selObjs.front())).position();
	nBlock.name() = "NewBlock";

	CreateInputPorts(nBlock, selObjs.front(), focusExpr, inputMap);
	CreateOutputPorts(nBlock, *(--selObjs.end()), focusExpr, outputMap);

	/* Move all of the selected objects to the newly created block; we can do this now because we have already put the ports that need to 
	   be connected into a map */
	for(list<Udm::Object>::iterator lit = selObjs.begin();lit!=selObjs.end();++lit)
	{
		UMLModelTransformer::MgaObject expression = UMLModelTransformer::MgaObject::Cast(*lit);
		expression.parent() = nBlock;
	}

	for(IOMap::iterator iot = portMap.begin();iot!=portMap.end();++iot)
	{
		UMLModelTransformer::Sequence freshSeq = UMLModelTransformer::Sequence::Create(nBlock);
		freshSeq.srcSequence_end() = (*iot).second;
		freshSeq.dstSequence_end() = (*iot).first;
	}

	CreateConnections<IIMap>(inputMap, nBlock);
	CreateConnections<OOMap>(outputMap, nBlock);
}

template<typename T> void CreateConnections(T inMap, UMLModelTransformer::Block &nBlock)
{
	for(T::iterator it = inMap.begin(); it != inMap.end(); ++it)
	{
		UMLModelTransformer::Sequence freshSeq = UMLModelTransformer::Sequence::Create(nBlock);
		freshSeq.srcSequence_end() = (*it).first;
		freshSeq.dstSequence_end() = (*it).second;
	}
}

void CreateInputPorts(UMLModelTransformer::Expression &blank, Udm::Object& oold, UMLModelTransformer::Expression focusObj, IIMap &inputMap)
{
	UMLModelTransformer::Expression old = GetExpression(oold);

	set<UMLModelTransformer::In> inPorts = old.In_kind_children();

	for(set<UMLModelTransformer::In>::iterator it = inPorts.begin(); it != inPorts.end(); ++it)
	{
		UMLModelTransformer::In nIn = UMLModelTransformer::In::Create(blank);
		nIn.position() = (*it).position();
		nIn.name() = (*it).name();

		set< UMLModelTransformer::Sequence> sequences= (*it).srcSequence();
		//the input port had some incoming connections, so find them and re-assemble :)
		for(set< UMLModelTransformer::Sequence>::iterator seqIt = sequences.begin(); seqIt != sequences.end(); ++seqIt)
		{
			UMLModelTransformer::ExpressionRef rpCont = seqIt->In_end__rp_helper();
			if ((rpCont && rpCont != oold) ||
				(!rpCont && old != oold)) {
				continue;
			}
			UMLModelTransformer::Port otherOut= (*seqIt).srcSequence_end();
			if(Uml::IsDerivedFrom( otherOut.type(), UMLModelTransformer::Out::meta))
			{	
				UMLModelTransformer::Out currOut= UMLModelTransformer::Out::Cast( otherOut);

				/* Now do the following:
					1. Create a new input port in blank
					2. Connect currOut to the new input port
					3. Connect the new input port to (*it)
					4. Delete *seqIt
				*/

				UMLModelTransformer::Sequence nSeq = UMLModelTransformer::Sequence::Create(focusObj);
				nSeq.Out_end__rp_helper() = seqIt->Out_end__rp_helper();
				nSeq.srcSequence_end() = currOut;
				nSeq.dstSequence_end() = nIn;
				inputMap.insert(pair<UMLModelTransformer::In, UMLModelTransformer::In>(nIn, (*it)));
			}
			else if(Uml::IsDerivedFrom( otherOut.type(), UMLModelTransformer::In::meta)) /* Input to Input */
			{
				UMLModelTransformer::In currOut= UMLModelTransformer::In::Cast( otherOut);

				/* Now do the following:
					1. Create a new input port in blank
					2. Connect currOut to the new input port
					3. Connect the new input port to (*it)
					4. Delete *seqIt
				*/

				UMLModelTransformer::Sequence nSeq = UMLModelTransformer::Sequence::Create(focusObj);
				nSeq.Out_end__rp_helper() = seqIt->Out_end__rp_helper();
				nSeq.srcSequence_end() = currOut;
				nSeq.dstSequence_end() = nIn;
				inputMap.insert(pair<UMLModelTransformer::In, UMLModelTransformer::In>(nIn, (*it)));
			}
		}
	}
}

void CreateOutputPorts(UMLModelTransformer::Expression &blank, Udm::Object& oold, UMLModelTransformer::Expression focusObj, OOMap &outputMap)
{
	UMLModelTransformer::Expression old = GetExpression(oold);
	set<UMLModelTransformer::Out> outPorts = old.Out_kind_children();

	for(set<UMLModelTransformer::Out>::iterator it = outPorts.begin(); it != outPorts.end(); ++it)
	{
		UMLModelTransformer::Out nOut = UMLModelTransformer::Out::Create(blank);
		nOut.position() = (*it).position();
		nOut.name() = (*it).name();

		set< UMLModelTransformer::Sequence> sequences= (*it).dstSequence();
		//the output port had some outgoing connections, so find them and re-assemble
		for(set< UMLModelTransformer::Sequence>::iterator seqIt = sequences.begin(); seqIt != sequences.end(); ++seqIt)
		{
			UMLModelTransformer::ExpressionRef rpCont = seqIt->Out_end__rp_helper();
			if ((rpCont && rpCont != oold) ||
				(!rpCont && old != oold)) {
				continue;
			}
			UMLModelTransformer::Port otherIn= (*seqIt).dstSequence_end();
			if(Uml::IsDerivedFrom( otherIn.type(), UMLModelTransformer::In::meta))
			{
				UMLModelTransformer::In currIn= UMLModelTransformer::In::Cast( otherIn);

				/* Now do the following:
					1. Create a new output port in blank
					2. Connect currOut to the new input port
					3. Connect the new input port to (*it)
					4. Delete *seqIt
				*/

				UMLModelTransformer::Sequence nSeq = UMLModelTransformer::Sequence::Create(focusObj);
				nSeq.srcSequence_end() = nOut;
				nSeq.In_end__rp_helper() = seqIt->In_end__rp_helper();
				nSeq.dstSequence_end() = currIn;
				outputMap.insert(pair<UMLModelTransformer::Out, UMLModelTransformer::Out>(*it, nOut));
			}

			else if(Uml::IsDerivedFrom( otherIn.type(), UMLModelTransformer::Out::meta))
			{
				UMLModelTransformer::Out currIn= UMLModelTransformer::Out::Cast( otherIn);

				/* Now do the following:
					1. Create a new output port in blank
					2. Connect currOut to the new input port
					3. Connect the new input port to (*it)
					4. Delete *seqIt
				*/

				UMLModelTransformer::Sequence nSeq = UMLModelTransformer::Sequence::Create(focusObj);
				nSeq.srcSequence_end() = nOut;
				nSeq.In_end__rp_helper() = seqIt->In_end__rp_helper();
				nSeq.dstSequence_end() = currIn;
				outputMap.insert(pair<UMLModelTransformer::Out, UMLModelTransformer::Out>(*it, nOut));
			}
		}

	}

}

void FillMap(map<UMLModelTransformer::In, UMLModelTransformer::Out> &portMap, list<Udm::Object> objs)
{
	for(list<Udm::Object>::iterator it = objs.begin(); it != objs.end(); ++it)
	{
		if(it == objs.begin())
			continue;
		UMLModelTransformer::Expression expr = GetExpression(*it);
		set<UMLModelTransformer::In> inPorts = expr.In_kind_children();
		for(set<UMLModelTransformer::In>::iterator portItr = inPorts.begin(); portItr != inPorts.end(); ++portItr)
		{
			set<UMLModelTransformer::Sequence> sequences= (*portItr).srcSequence();
			for(set< UMLModelTransformer::Sequence>::iterator seqIt = sequences.begin(); seqIt != sequences.end(); ++seqIt)
			{
				UMLModelTransformer::Port otherOut= (*seqIt).srcSequence_end();
				if( false== Uml::IsDerivedFrom( otherOut.type(), UMLModelTransformer::Out::meta))
					continue;
				UMLModelTransformer::Expression currExpr = (*seqIt).Expression_parent();
				Udm::Object ob = expr.parent();
				if(currExpr.uniqueId() != ob.uniqueId())
					continue;
				UMLModelTransformer::Out currOut= UMLModelTransformer::Out::Cast( otherOut);
				portMap.insert(pair<UMLModelTransformer::In, UMLModelTransformer::Out>(*portItr, currOut));
			}
		}

	}
	
}

