// ConfigurationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ConfigurationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "GridBtnCell_src\GridBtnCell.h"
#include "GridBtnCell_src\GridBtnCellCombo.h"
#include "NewCellTypes\GridCellCombo.h"

#define FIXED_ROW_COUNT         1
#define FIXED_COLUMN_COUNT      0
#define COLUMN_COUNT            5

/////////////////////////////////////////////////////////////////////////////
// CConfigurationDlg dialog

CConfigurationDlg::CConfigurationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigurationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigurationDlg)
	//}}AFX_DATA_INIT
}

CConfigurationDlg::CConfigurationDlg(vector<FileTypeInfo> *ftInfos, CWnd* pParent)
	: CDialog(CConfigurationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ConfigDlg)
	//}}AFX_DATA_INIT
	fileTypeInfos = ftInfos;
}

void CConfigurationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigurationDlg)
	DDX_Control(pDX, IDC_GRID, m_Grid);             // associate the grid window with a C++ object

	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigurationDlg, CDialog)
	//{{AFX_MSG_MAP(CConfigurationDlg)
	ON_NOTIFY(GVN_ENDLABELEDIT, IDC_GRID, OnGridEndEdit)
    ON_NOTIFY(NM_CLICK, IDC_GRID, OnGridClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigurationDlg message handlers

void CConfigurationDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CConfigurationDlg::OnOK() 
{
	// TODO: Add extra validation here
	int row = 0;
	for(vector<FileTypeInfo>::iterator i=fileTypeInfos->begin(); i!=fileTypeInfos->end(); ++i)
	{
		row++;  // for the seperator
		
		i->fileId = m_Grid.GetCell(row++,1)->GetText(); 
		i->metaName = m_Grid.GetCell(row++,1)->GetText(); 
		i->rootClsName = m_Grid.GetCell(row++,1)->GetText(); 
		i->fileMode = m_Grid.GetCell(row++,1)->GetText();
		CString str = m_Grid.GetCell(row++,1)->GetText();
		i->useMem = (str=="true") ? true : false;
		i->xsdPathName = m_Grid.GetCell(row++,1)->GetText();
		i->filePath = m_Grid.GetCell(row++,1)->GetText();
		i->copyPath = m_Grid.GetCell(row++,1)->GetText();
		
		//Update the start object path
		for(map<UMLModelTransformer::In, string>::const_iterator pos=(i->startObjPath).begin();pos!=(i->startObjPath).end();++pos)
		{
			UMLModelTransformer::In in = (*pos).first;
			i->startObjPath[in] = m_Grid.GetCell(row++, 1)->GetText();
		}
	}

	CDialog::OnOK();
}

void CConfigurationDlg::CreateButtonCell(int row, int col)
{
	int iComboCtlWidth = GetSystemMetrics( SM_CXVSCROLL);
	CGridBtnCell GridCellCopy;
	GridCellCopy.SetBtnDataBase( &m_BtnDataBase);
	CGridCellBase* pCurrCell = m_Grid.GetCell( row, col);
	if (pCurrCell)
	GridCellCopy = *pCurrCell;

	m_Grid.SetCellType(row,col,RUNTIME_CLASS(CGridBtnCellCombo));
	CGridBtnCellCombo* pGridBtnCellCombo = (CGridBtnCellCombo*)m_Grid.GetCell(row, col);
	pGridBtnCellCombo->SetComboStyle(CBS_SIMPLE);

	CGridBtnCell* pGridBtnCell = (CGridBtnCell*)m_Grid.GetCell(row, col);
	pGridBtnCell->SetBtnDataBase(&m_BtnDataBase);

	pGridBtnCell->SetupBtns(0,DFCS_BUTTONPUSH,FALSE,CGridBtnCellBase::CTL_ALIGN_RIGHT,iComboCtlWidth+10, 0, "...");
}


void CConfigurationDlg::CreateListCell(int row, int col, const CStringArray &textlist)
{
	m_Grid.SetCellType(row,col,RUNTIME_CLASS(CGridCellCombo));
	CGridCellCombo* pCell = (CGridCellCombo*)m_Grid.GetCell(row, col);

	pCell->SetOptions(textlist);
//	pCell->SetText(textlist.GetAt(0));
	pCell->SetStyle(CBS_DROPDOWN);
}

BOOL CConfigurationDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_Grid.SetEditable(TRUE);

	m_Grid.SetGridLines(GVL_HORZ);
	m_Grid.SetColumnCount(2);
	int cnt = 0;
	string items[] = {"FileTypeID:", "Meta name:", "RootClass name:", "File mode:", "Run in memory?", "DTD/XSD file path:","Open/Write/Update File name:", "Copy file name:"};

	for(vector<FileTypeInfo>::const_iterator i=fileTypeInfos->begin(); i!=fileTypeInfos->end(); ++i)
	{
		int row = m_Grid.GetRowCount();
		int size = i->startObjPath.size()+9;
		m_Grid.SetRowCount(row+size);
		//Title, Seperator
		m_Grid.SetItemState(row, 0, m_Grid.GetItemState(row,0) | GVIS_READONLY);
		m_Grid.SetItemState(row, 1, m_Grid.GetItemState(row,1) | GVIS_READONLY);
		m_Grid.SetItemText(row,1,(i->metaName).c_str());
		//Background color
		m_Grid.GetCell(row,0)->SetBackClr(RGB(0xFF, 0xFF, 0xCC));
		m_Grid.GetCell(row,1)->SetBackClr(RGB(0xFF, 0xFF, 0xCC));
		//Set Margin
		m_Grid.GetCell(row,1)->SetMargin(10);
		//Add Height
		m_Grid.SetRowHeight(row, m_Grid.GetRowHeight(row)+10);

		int r;
		for(r=1; r<9; ++r)
		{
			m_Grid.GetCell(row+r,0)->SetBackClr(RGB(0xDD, 0xDD, 0xDD));
			m_Grid.SetItemState(row+r, 0, m_Grid.GetItemState(row+r,0) | GVIS_READONLY);
			m_Grid.SetItemText(row+r, 0, items[r-1].c_str());
		}
		if(!i->fileId.empty())
			m_Grid.SetItemText(row+1, 1, (i->fileId).c_str());
		else
			m_Grid.SetItemText(row+1, 1, (i->metaName+"_File").c_str());
		m_Grid.SetItemText(row+2, 1, (i->metaName).c_str());
		m_Grid.SetItemState(row+2, 1, m_Grid.GetItemState(row+2,1) | GVIS_READONLY);

		CStringArray list;
		if(i->rootClsName_set.size()==1)
			m_Grid.SetItemText(row+3, 1, (i->rootClsName).c_str());
		else
		{
			for(set<string>::const_iterator si=i->rootClsName_set.begin();si!=i->rootClsName_set.end();++si)
			{
				list.Add(_T((*si).c_str()));
			}				
			CreateListCell(row+3,1, list);
			m_Grid.SetItemText(row+3, 1, list.GetAt(0));
		}

		list.RemoveAll();
		list.Add(_T("read"));	
		list.Add(_T("write"));
		list.Add(_T("read and write")); 
		list.Add(_T("read and write to a copy"));
		CreateListCell(row+4,1, list);
		m_Grid.SetItemText(row+4, 1, (i->fileMode).c_str());

		list.RemoveAll();
		list.Add(_T("false"));
		list.Add(_T("true"));
		CreateListCell(row+5,1, list);
		if(i->useMem) m_Grid.SetItemText(row+5, 1, "true");
		else m_Grid.SetItemText(row+5, 1, "false");
		
		m_Grid.SetItemText(row+6, 1, (i->xsdPathName).c_str());
	
		m_Grid.SetItemText(row+7, 1, (i->filePath).c_str());
		CreateButtonCell(row+7,1);
		m_Grid.SetItemText(row+8, 1, (i->copyPath).c_str());
		CreateButtonCell(row+8,1);

		//start object path
		int rcnt = row+9;
		for(map<UMLModelTransformer::In, string>::const_iterator pos=(i->startObjPath).begin();pos!=(i->startObjPath).end();++pos)
		{
			UMLModelTransformer::In in = (*pos).first;
			string objPath = (*pos).second;
			m_Grid.GetCell(rcnt,0)->SetBackClr(RGB(0xDD, 0xDD, 0xDD));
			m_Grid.SetItemState(rcnt, 0, m_Grid.GetItemState(row+r,0) | GVIS_READONLY);
			string index = "StartObject \""+ ((string)(in.name()))+"\" path:";
			m_Grid.SetItemText(rcnt, 0, index.c_str());
			m_Grid.SetItemText(rcnt, 1, objPath.c_str());
			rcnt++;
		}
		
		cnt++;
	}

	m_Grid.AutoSizeColumn(0); m_Grid.SetColumnWidth(0, m_Grid.GetColumnWidth(0)+5);

	m_Grid.ExpandLastColumn();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConfigurationDlg::OnGridEndEdit(NMHDR *pNotifyStruct, LRESULT* pResult)
{
    NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;
}

void CConfigurationDlg::OnGridClick(NMHDR *pNotifyStruct, LRESULT* pResult)
{
    NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;
    CString strMsg;

    int nRow = pItem->iRow;
    int nCol = pItem->iColumn;

    *pResult = 0;
    if( nRow < m_Grid.GetFixedRowCount() )
        return;

    CGridBtnCellCombo* pGridBtnCellCombo;

    pGridBtnCellCombo = (CGridBtnCellCombo*)m_Grid.GetCell( nRow, nCol);	
    
	if( !pGridBtnCellCombo->IsKindOf( RUNTIME_CLASS(CGridBtnCellCombo) ) )
    {
		CGridCellCombo* pListCell;
		pListCell = (CGridCellCombo*)m_Grid.GetCell(nRow, nCol);
		if(!pListCell->IsKindOf(RUNTIME_CLASS(CGridCellCombo))) return;
		if(pListCell->GetStyle()==CBS_DROPDOWN)
		{
			m_Grid.SetItemText(nRow,nCol,pListCell->GetText());
			m_Grid.RedrawCell(nRow, nCol);
			UpdateData(TRUE);
			return;
		}
		return;
    }
	
	if( pGridBtnCellCombo->GetLastCtlClicked() < 0)
	{
		return;	
	}

	if( pGridBtnCellCombo->GetLastCtlClicked() == 0 && pGridBtnCellCombo->GetComboStyle()==CBS_SIMPLE)
	{
		static char szFilter[]="UDM Backend Files (*.mga,*.xml,*.mem)|*.mga;*.xml;*.mem|\
			MGA Files(*.mga)|*.mga|XML Files (*.xml)|*.xml|\
			MEM Files (*.mem)|*.mem|All Files (*.*)|*.*||";
		bool bOpenFileDialog = true;
		CString str = m_Grid.GetItemText(nRow,0);
		CString mode = m_Grid.GetItemText(nRow-3,1);
		if(str=="Copy file name:" || mode=="write") bOpenFileDialog = false;
		DWORD dwFlags = OFN_OVERWRITEPROMPT;
		CFileDialog dlgDOM(bOpenFileDialog,"",NULL,dwFlags,szFilter,NULL);
		if(dlgDOM.DoModal()==IDOK)
		{	
			m_Grid.SetItemText(nRow,nCol,dlgDOM.GetPathName());
			m_Grid.RedrawCell( nRow, nCol);
			UpdateData(TRUE);
		}
	}
}
