/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/


// UdmApp.cpp: implementation of the CUdmApp class.
// This file was automatically generated as UdmApp.cpp
// by UDM Interpreter Wizard on Monday, May 13, 2002 13:45:42

// Tihamr Levendovszky 05-13-02

#include "stdafx.h"
#include <afxdlgs.h> // For CFileDialog
#include "resource.h"

//#include <iostream.h>
#include <atlbase.h>
#include <comdef.h>

#include <time.h>
#include "UdmStatic.h"
#include "UdmDom.h"
#include "UdmGME.h"
#include "UmlExt.h"
#include "UdmUtil.h"

#include "UdmApp.h"
#include "UdmConfig.h"

#include "resource.h"
#include "ConfigurationDlg.h"

#include <direct.h>

extern void dummy(void); // Dummy function for UDM meta initialization


UMLModelTransformer::Class getClass(const UMLModelTransformer::ClassBase &clsbase);
bool getClass(const UMLModelTransformer::Port &port, UMLModelTransformer::Class &cls);
string getMetaName(const UMLModelTransformer::Class &cls);
void getClassPath(const UMLModelTransformer::Class &cls, string &path);
void getCompositions(const UMLModelTransformer::Class &cls, set<UMLModelTransformer::Composition> &comps);
bool isRootClass(const UMLModelTransformer::Class &cls);
void getPackages(const UMLModelTransformer::Expression &expression, set<UMLModelTransformer::Package> &pkgs);
void getPackages(const UMLModelTransformer::RootFolder &rf, set<UMLModelTransformer::Package> &pkgs);
void getFileTypeInfo(UMLModelTransformer::Package &pkg, vector<FileTypeInfo> &infos);
bool setFileTypeInfo(UMLModelTransformer::Package &pkg, FileTypeInfo &info, UMLModelTransformer::FileType &ftype);
void collectClasses(UMLModelTransformer::Namespace &ns, set<UMLModelTransformer::Class> &clss);
string getClassFullName(const UMLModelTransformer::Class &cls);

map<string, set<UMLModelTransformer::In> > meta2ins;
map<string, UMLModelTransformer::FileType> filetypesMap;
UMLModelTransformer::Configuration cfgmodel;

//static UMLModelTransformer::Expression startrule;

/*********************************************************************************/
/* Initialization function. The framework calls it before preparing the backend. */
/* Initialize here the settings in the config static object.					 */
/* Return 0 if successful.														 */
/*********************************************************************************/
int CUdmApp::Initialize()
{
	// TODO: Your initialization code comes here...
	return 0;
}

/* 
Remarks to CUdmApp::UdmMain(...):
0.	The p_backend points to an already open backend, and the framework 
	closes it automatically. DO NOT OPEN OR CLOSE IT!
	To commit changes use p_backend->CommitEditSequence().
	To abort changes use p_backend->AbortEditSequence().
	To save changes to a different file use p_backend->SaveAs() or p_backend->CloseAs().

1.	Focus is the currently open model.

2.	The possible values for param (from GME DecoratorLib.h component_startmode_enum):
	GME_MAIN_START			=   0,
	GME_BROWSER_START		=   1,
	GME_CONTEXT_START		=   2,
	GME_EMBEDDED_START		=   3,
	GME_MENU_START			=  16,
	GME_BGCONTEXT_START		=  18,
	GME_ICON_START			=  32,
	METAMODEL_CHECK_SYNTAX	= 101

 3. The framework catches all the exceptions and reports the error in a message box,
	clean up and close the transactions aborting the changes. You can override this 
	behavior by catching udm_exception. Use udm_exception::what() to form an error 
	message.
*/

/***********************************************/
/* Main entry point for Udm-based Interpreter  */
/***********************************************/
//CGREngineDlgDlg* CUdmApp::m_pDialog = 0;

void CUdmApp::UdmMain(
					 Udm::DataNetwork* p_backend,		// Backend pointer(already open!)
					 Udm::Object focusObject,			// Focus object
					 set<Udm::Object> selectedObjects,	// Selected objects
					 long param)						// Parameters
{	
	// TODO: Your Code Comes Here...
	try
	{
		UMLModelTransformer::RootFolder rf = UMLModelTransformer::RootFolder::Cast(p_backend->GetRootObject());

		//aggregate the packages based on the startrul if there is
		UMLModelTransformer::Configurations cfgfdr;
		UMLModelTransformer::Expression startrule;
		const set<UMLModelTransformer::Configurations> cfgfdrs = rf.Configurations_children();
		if(!cfgfdrs.empty())
			cfgfdr = *(cfgfdrs.begin());
		else
		{
			cfgfdr = UMLModelTransformer::Configurations::Create(rf);
			cfgfdr.name() = "ConfigurationFolder";
		}
		const set<UMLModelTransformer::Configuration> cfgs = cfgfdr.Configuration_kind_children();
		if(!cfgs.empty())
		{
			cfgmodel = *(cfgs.begin());
			set<UMLModelTransformer::StartRule> srules = cfgmodel.StartRule_children();
			if(!srules.empty())
			{
				UMLModelTransformer::StartRule srule = *(srules.begin());
				UMLModelTransformer::Expression expression = srule.ref();
				if(expression!=Udm::null) startrule = srule.ref();
			}
		}
		else 
		{
			cfgmodel = UMLModelTransformer::Configuration::Create(cfgfdr);
			cfgmodel.name() = "Configuration";
		}
				
		//aggregate the existed filetype
		const set<UMLModelTransformer::FileType> fts = cfgmodel.FileType_children();
		for(set<UMLModelTransformer::FileType>::const_iterator fi=fts.begin();fi!=fts.end();++fi)
		{
			string name = (*fi).name();
			string mname = (*fi).MetaName();
			if(name.empty() || filetypesMap.find(name)!=filetypesMap.end()) 
			{
				int memrand = rand();
				char buffer[20];
				_itoa(memrand, buffer, 10);
				string randname(buffer);
				name = mname+"_File"+randname;
				(*fi).name() = name;
			}
			filetypesMap[name] = *fi;
		}

		set<UMLModelTransformer::Package> pkgs;
		if(startrule!=Udm::null) getPackages(startrule, pkgs);
		else getPackages(rf, pkgs);
		
	//Collect the attribute of FileType and create File, FileObject 
		vector<FileTypeInfo> ftInfos;
		for(set<UMLModelTransformer::Package>::const_iterator i=pkgs.begin(); i!=pkgs.end(); ++i)
		{
			UMLModelTransformer::Package pkg = *i;
			if(pkg.temporary()) continue;
			//	FileTypeInfo info;
			getFileTypeInfo(pkg, ftInfos);
		}	

		CConfigurationDlg cdlg(&ftInfos);
		if(cdlg.DoModal() == IDCANCEL)
		{
			filetypesMap.clear();
			meta2ins.clear();
			p_backend->AbortEditSequence();
			return;
		}

		// Update Configuration model
		
		//Create metainfomation model if there is none
		set<UMLModelTransformer::MetaInformation> metainfos = cfgmodel.MetaInformation_children();
		if(metainfos.empty())
		{
			UMLModelTransformer::MetaInformation metainfo = UMLModelTransformer::MetaInformation::Create(cfgmodel);
			metainfo.name() = "MetaInfomation";
		}

		int cnt = 0;
		for(vector<FileTypeInfo>::iterator j=ftInfos.begin();j!=ftInfos.end();++j)
		{
			UMLModelTransformer::FileType ftype;
			map<string, UMLModelTransformer::FileType>::iterator fpos=filetypesMap.find(j->fileId);
			ASSERT(fpos!=filetypesMap.end()); 
			ftype = (*fpos).second;

			char ch[20];
			int ypos;
			if(ftype==Udm::null)
			{
				ftype = UMLModelTransformer::FileType::Create(cfgmodel);
				ypos = 100+120*cnt;
				_itoa(ypos,ch,10);
				ftype.position() = "(250, "+string(ch)+")";
			}

			ftype.name() = j->fileId;			
			ftype.MetaName() = j->metaName;
			ftype.RootClassName() = j->rootClsName;
			ftype.Mode() = j->fileMode;
			ftype.RunInMemory() = j->useMem;
			ftype.DtdFilePath() = j->xsdPathName;

			//Create File if there is none
			UMLModelTransformer::File file;
			const set<UMLModelTransformer::FileBind> fbindings = ftype.srcFileBind();
			if(!fbindings.empty())
			{
				const UMLModelTransformer::FileBind fbinding = *(fbindings.begin());
				file = fbinding.srcFileBind_end();
			}
			else
			{
				file = UMLModelTransformer::File::Create(cfgmodel);
				file.name() = j->fileId+"_File";
				UMLModelTransformer::FileBind filebind = UMLModelTransformer::FileBind::Create(cfgmodel);
				filebind.dstFileBind_end() = ftype;
				filebind.srcFileBind_end() = file;
				ypos = 110+120*cnt;
				_itoa(ypos,ch,10);
				file.position() = "(100, "+string(ch)+")";		
			}
				
			file.FilePathName() = j->filePath;
			file.CopyPathName() = j->copyPath;

			//Create the FileObject if there is none
			for(map<UMLModelTransformer::In, string>::const_iterator pos=j->startObjPath.begin();pos!=j->startObjPath.end();++pos)
			{
				UMLModelTransformer::In in = (*pos).first;
				UMLModelTransformer::FileObject fobj;
				set<UMLModelTransformer::TransformationInput> tinputs = in.srcTransformationInput();
				if(!tinputs.empty())
				{
					fobj = (*(tinputs.begin())).srcTransformationInput_end();
					UMLModelTransformer::FileType filetype_parent = fobj.FileType_parent();
					if(filetype_parent != ftype)
						throw udm_exception("FileObject "+(string)fobj.name()+" belongs to the wrong meta.");
				}
				else
				{
					fobj = UMLModelTransformer::FileObject::Create(ftype);
					fobj.position() = "(500,200)";
					fobj.name() = "startObject_"+(string)in.name();
					UMLModelTransformer::TransformationInput tinput = UMLModelTransformer::TransformationInput::Create(cfgmodel);
					tinput.srcTransformationInput_end() = fobj;
					tinput.dstTransformationInput_end() = in;
				}
				fobj.ObjectPath() = (*pos).second;
			}
			
			cnt++;
		}

		filetypesMap.clear();
		meta2ins.clear();
	}
	catch(udm_exception &e)
	{
		AfxMessageBox(CString("Exception: ")+CString(e.what()));
	}				
}

void getPackages(const UMLModelTransformer::Expression &expression, set<UMLModelTransformer::Package> &pkgs)
{
	set<UMLModelTransformer::In> ins = expression.In_kind_children();
	for(set<UMLModelTransformer::In>::iterator pi=ins.begin();pi!=ins.end();++pi)
	{
		UMLModelTransformer::In in = *pi;
		UMLModelTransformer::Class cls;
		if(!getClass(in, cls)) continue;
		
//		inport2class[in] = cls;
		const UMLModelTransformer::ClassDiagram clsdgm = cls.ClassDiagram_parent();
		//take care of NameSpace here:
//		const UMLModelTransformer::Package pkg = clsdgm.Package_parent();
		Udm::Object pobj = clsdgm.parent();
		while(pobj.type()==UMLModelTransformer::Namespace::meta)
		{
			UMLModelTransformer::Namespace ns = UMLModelTransformer::Namespace::Cast(pobj);
			pobj = ns.parent();
		}
		ASSERT(pobj.type()==UMLModelTransformer::Package::meta);
		const UMLModelTransformer::Package pkg = UMLModelTransformer::Package::Cast(pobj);
		pkgs.insert(pkg);
		set<UMLModelTransformer::In> ins;
		map<string, set<UMLModelTransformer::In> >::iterator pos=meta2ins.find((string)pkg.name());
		if(pos!=meta2ins.end()) ins = (*pos).second;
		ins.insert(in);
		meta2ins[(string)(pkg.name())] = ins;
	}
}

string getClassFullName(const UMLModelTransformer::Class &cls)
{
	string fname = cls.name();
	const UMLModelTransformer::ClassDiagram clsdgrm = cls.ClassDiagram_parent();
	Udm::Object pobj = clsdgrm.parent();
	while(pobj.type() == UMLModelTransformer::Namespace::meta)
	{
		UMLModelTransformer::Namespace ns = UMLModelTransformer::Namespace::Cast(pobj);
		fname = (string)ns.name()+"::"+fname;
		pobj = ns.parent();
	}
	return fname;
}

void getPackages(const UMLModelTransformer::RootFolder &rf, set<UMLModelTransformer::Package> &pkgs)
{
	pkgs = rf.Package_kind_children();
	const set<UMLModelTransformer::RootFolder> rtfdrs = rf.RootFolder_children();
	for(set<UMLModelTransformer::RootFolder>::const_iterator ri=rtfdrs.begin();ri!=rtfdrs.end();++ri)
	{
		set<UMLModelTransformer::Package> rt_pkgs = (*ri).Package_kind_children();
		pkgs.insert(rt_pkgs.begin(), rt_pkgs.end());
	}
}

string getMetaName(const UMLModelTransformer::Class &cls)
{
	const UMLModelTransformer::ClassDiagram clsdgm = cls.ClassDiagram_parent();
	const UMLModelTransformer::Package pkg = clsdgm.Package_parent();
	return pkg.name();
}

void getClassPath(const UMLModelTransformer::Class &cls, string &path)
{
	set<UMLModelTransformer::Composition> comps;
	set<UMLModelTransformer::Composition> comps_c = cls.dstParent();
	comps.insert(comps_c.begin(), comps_c.end());
	const set<UMLModelTransformer::ClassCopy> ccopys = cls.src();
	for(set<UMLModelTransformer::ClassCopy>::const_iterator ci=ccopys.begin();ci!=ccopys.end();++ci)
	{
		comps_c = ci->dstParent();
		comps.insert(comps_c.begin(), comps_c.end());
	}

	if(comps.empty()) return;

	for(set<UMLModelTransformer::Composition>::const_iterator k=comps.begin();k!=comps.end();++k)
	{
		UMLModelTransformer::ClassBase parentCls = (*k).dstParent_end();
		UMLModelTransformer::Class pclass = getClass(parentCls);
		string fname = getClassFullName(pclass);
		//take care of the NameSpace here:
//		if((string)getClass(pclass).name()!= (string)cls.name() && !pclass.IsAbstract()) 
		if(fname!= getClassFullName(cls) && !pclass.IsAbstract()) 
		{	
//			path = (string)pclass.name()+";"+path;
			path = fname+";"+path;
			return getClassPath(pclass, path);
		}
	}

	return;	
}

//bool getClass(const UMLModelTransformer::In &inport, UMLModelTransformer::Class &cls)
bool getClass(const UMLModelTransformer::Port &port, UMLModelTransformer::Class &cls)
{
	UMLModelTransformer::Expression inparent = port.Expression_parent();
	if((string)inparent.type().name()!="Rule")
	{
		const set<UMLModelTransformer::Sequence> sequences = port.dstSequence();
		for(set<UMLModelTransformer::Sequence>::const_iterator i=sequences.begin();i!=sequences.end();++i)
		{
			UMLModelTransformer::Port dport = i->dstSequence_end();
		//	if((string)dport.type().name()!= "In") continue;
		//	const UMLModelTransformer::In inin = UMLModelTransformer::In::Cast(port);
			return getClass(dport, cls);
		}
	}
	else 
	{
		const set<UMLModelTransformer::Binding> bindings = port.dstBinding();
		if(bindings.empty()) return false;
		const UMLModelTransformer::Binding binding = *(bindings.begin());
		UMLModelTransformer::Binding_Members_Base mbase = binding.dstBinding_end();
		if((string)mbase.type().name()!= "PatternClass") return false;
		const UMLModelTransformer::PatternClass pcls = UMLModelTransformer::PatternClass::Cast(mbase);
		const UMLModelTransformer::ClassBase cbase = pcls.ref();
		if((string)cbase.type().name()=="Class") cls = UMLModelTransformer::Class::Cast(cbase);
		else cls = UMLModelTransformer::ClassCopy::Cast(cbase).ref();
		return true;
	}
}

UMLModelTransformer::Class getClass(const UMLModelTransformer::ClassBase &clsbase)
{
	if((string)(clsbase.type().name()) == "Class") return(UMLModelTransformer::Class::Cast(clsbase));
	else return(UMLModelTransformer::ClassCopy::Cast(clsbase).ref());
}

void getCompositions(const UMLModelTransformer::Class &cls, set<UMLModelTransformer::Composition> &comps)
{
	set<UMLModelTransformer::Composition> comps_temp = cls.dstParent();
	if(!comps_temp.empty()) comps.insert(comps_temp.begin(), comps_temp.end());

	//Check the reference
	const set<UMLModelTransformer::ClassCopy> ccopys = cls.src();
	set<UMLModelTransformer::ClassCopy>::const_iterator ci;
	for(ci=ccopys.begin();ci!=ccopys.end();++ci)
	{
		comps_temp = (*ci).dstParent();
		if(!comps_temp.empty()) comps.insert(comps_temp.begin(), comps_temp.end());
	}
	
	//Check the ancestor
	set<UMLModelTransformer::Sub> subs = cls.srcInheritance();
	for(ci=ccopys.begin();ci!=ccopys.end();++ci)
	{
		set<UMLModelTransformer::Sub> subs_c = (*ci).srcInheritance();
		subs.insert(subs_c.begin(), subs_c.end());
	}
	for(set<UMLModelTransformer::Sub>::iterator si=subs.begin();si!=subs.end();++si)
	{
		UMLModelTransformer::Inheritance inheri = (*si).srcInheritance_end();
		set<UMLModelTransformer::Base> bases = inheri.srcClassBase();
		for(set<UMLModelTransformer::Base>::iterator bi=bases.begin();bi!=bases.end();++bi)
		{
			UMLModelTransformer::ClassBase cbase = (*bi).srcClassBase_end();
			getCompositions(getClass(cbase), comps);
		}
	}
}

bool isRootClass(const UMLModelTransformer::Class &cls)
{
	if(cls.IsAbstract()) return false;
	set<UMLModelTransformer::Composition> comps;
	getCompositions(cls, comps);
	for(set<UMLModelTransformer::Composition>::const_iterator k=comps.begin();k!=comps.end();++k)
	{
		UMLModelTransformer::ClassBase parentCls = (*k).dstParent_end();
		if((string)getClass(parentCls).name()!= (string)cls.name()) return false;				
	}
	
	return true;
}

void getFileTypeInfo(UMLModelTransformer::Package &pkg, vector<FileTypeInfo> &infos)
{
	if(pkg.temporary()) return;

//	map<string, UMLModelTransformer::FileType>::iterator pos=meta2filetypes.find(info.metaName);
	bool isExist = false;
	UMLModelTransformer::FileType ftype;
	for(map<string,UMLModelTransformer::FileType>::iterator i=filetypesMap.begin();i!=filetypesMap.end();++i)
	{
		ftype = (*i).second;
		if(ftype==Udm::null) continue;
		if((string)ftype.MetaName()!=(string)pkg.name()) continue;
		
		isExist=true;

		FileTypeInfo info;
		if(setFileTypeInfo(pkg, info, ftype)) infos.push_back(info);
	}
	
	if(!isExist)
	{
		FileTypeInfo info;

		if(setFileTypeInfo(pkg, info, ftype)) 
		{
			infos.push_back(info);
			filetypesMap[info.fileId] = ftype;
		}
	}
}

void collectClasses(UMLModelTransformer::Namespace &ns, set<UMLModelTransformer::Class> &clss)
{
	set<UMLModelTransformer::Namespace> nss = ns.Namespace_kind_children();
	for(set<UMLModelTransformer::Namespace>::iterator i=nss.begin();i!=nss.end();++i)
	{
		UMLModelTransformer::Namespace ns = *i;
		collectClasses(ns, clss);
	}
	const set<UMLModelTransformer::ClassDiagram> clsdgrms = ns.ClassDiagram_kind_children();
	for(set<UMLModelTransformer::ClassDiagram>::const_iterator it_dgrm=clsdgrms.begin(); it_dgrm!=clsdgrms.end(); ++it_dgrm)
	{
		set<UMLModelTransformer::Class> clss_this = it_dgrm->Class_kind_children();
		clss.insert(clss_this.begin(), clss_this.end());
	}
}

bool setFileTypeInfo(UMLModelTransformer::Package &pkg, FileTypeInfo &info, UMLModelTransformer::FileType &ftype)
{
	set<UMLModelTransformer::Class> clss;
	set<UMLModelTransformer::Namespace> nss = pkg.Namespace_kind_children();
	for(set<UMLModelTransformer::Namespace>::iterator it_ns=nss.begin();it_ns!=nss.end();++it_ns)
	{
		UMLModelTransformer::Namespace ns = *it_ns;
		collectClasses(ns, clss);
	}

	const set<UMLModelTransformer::ClassDiagram> clsdgrms = pkg.ClassDiagram_kind_children();
	for(set<UMLModelTransformer::ClassDiagram>::const_iterator i=clsdgrms.begin(); i!=clsdgrms.end(); ++i)
	{
		const set<UMLModelTransformer::Class> clss_this = i->Class_kind_children();
		clss.insert(clss_this.begin(), clss_this.end());
	}

	if(clss.empty()) return false;

	info.metaName = pkg.name();
	for(set<UMLModelTransformer::Class>::const_iterator j=clss.begin(); j!=clss.end(); ++j)
	{
		const UMLModelTransformer::Class cls = *j;
		//take care of NameSpace here:
//		if(isRootClass(cls)) info.rootClsName_set.insert((string)cls.name());
		if(isRootClass(cls)) info.rootClsName_set.insert(getClassFullName(cls));
	}
	
	if(info.rootClsName_set.empty()) 
		throw udm_exception(info.metaName+" has no rootclass found.");

	if(ftype!=Udm::null)
	{
		info.fileId = ftype.name();
		info.rootClsName = ftype.RootClassName();
		info.fileMode = ftype.Mode();
		info.xsdPathName = ftype.DtdFilePath();
		info.useMem = ftype.RunInMemory();
		//Check if there is file
		const set<UMLModelTransformer::FileBind> fbindings = ftype.srcFileBind();
		if(!fbindings.empty())
		{
			const UMLModelTransformer::FileBind fbinding = *(fbindings.begin());
			const UMLModelTransformer::File file = fbinding.srcFileBind_end();
			info.filePath = file.FilePathName();
			info.copyPath = file.CopyPathName();
		}
	}

	if(info.fileId.empty()) info.fileId = info.metaName+"_File";
	if(info.rootClsName.empty()) info.rootClsName = *(info.rootClsName_set.begin());
	if(info.xsdPathName.empty()) info.xsdPathName = "Udm\\"+info.metaName+".xsd";
	if(info.fileMode.empty()) info.fileMode = "read";

	//Check if there is FileObject associated with the pre-existed StartRule
	map<string, set<UMLModelTransformer::In> >::iterator ipos = meta2ins.find(info.metaName);
	if(ipos==meta2ins.end()) return true;
	const set<UMLModelTransformer::In> ins = (*ipos).second;
	for(set<UMLModelTransformer::In>::const_iterator ii=ins.begin();ii!=ins.end();++ii)
	{
		string objPath;
		UMLModelTransformer::Class cls;
		if(getClass((*ii), cls))
		{ 
			//take care of NameSpace here:
//			objPath = (string)cls.name()+";";
			objPath = getClassFullName(cls)+";";
			getClassPath(cls, objPath);
		}

		UMLModelTransformer::TransformationInput tinput;
		UMLModelTransformer::FileObject fobj;
		set<UMLModelTransformer::TransformationInput> tinputs = (*ii).srcTransformationInput();
		if(!tinputs.empty())
		{
			tinput = *(tinputs.begin());
			fobj = tinput.srcTransformationInput_end();
			UMLModelTransformer::FileType filetype_parent = fobj.FileType_parent();
			if(filetype_parent==ftype)
			{
				if(((string)(filetype_parent.MetaName())) != info.metaName)
					throw udm_exception("FileObject "+(string)fobj.name()+" belongs to the wrong meta.");
				fobj.ObjectPath() = objPath;
				info.startObjPath[*ii] = objPath;
			}
		}
		else info.startObjPath[*ii] = objPath;
	}

	return true;
}

