// UdmBackendDump.cpp : Defines the entry point for the console application.
//

// UdmBackendDump	-	Tihamr Levendovszky March, 2002


#include <iostream>
#include <sstream>


#include "ModelDiff.h"
#include "Uml.h"

using namespace std;

void dummy(void) {; } // Dummy function for initialization


int main(int argc, char* argv[])
{
	int ret;
	if(argc<4 || (argc%2 != 0)) 
	{
		cout<<"UdmModelDiff <to-be-checked model> <correct model> <backend_meta_file.xml> [ClassName NameAttr] [-r UnnamedRef]"<<endl;
		return -1;
	}

	try
	{	
		//preparing the surrogate name map
		for(int i = 4; i<argc; i = i+2)//already checked if argc an even number above
		{
			if(argv[i] == string("-r"))
			{
				AddUnnamedRef(argv[i+1]);
			}
			else
			{
				AddNameSurrogate(argv[i],argv[i+1]);
			}
		}

		// Loading the meta for the host graph
		Udm::SmartDataNetwork  meta(::Uml::diagram);	
		::Uml::Diagram theUmlDiagram;

		// Opening the XML meta of the host graph
		meta.OpenExisting(argv[3],"uml.dtd", Udm::CHANGES_LOST_DEFAULT);
		
		// Casting the DataNetwork to diagram
		theUmlDiagram = ::Uml::Diagram::Cast(meta.GetRootObject());
		
		// Creating the UDM diagram
		Udm::UdmDiagram udmDataDiagram;
		udmDataDiagram.dgr = &theUmlDiagram;
		udmDataDiagram.init = dummy;

		Udm::SmartDataNetwork src(udmDataDiagram), dst(udmDataDiagram);
		src.OpenExisting(argv[1], "", Udm::CHANGES_LOST_DEFAULT);
		dst.OpenExisting(argv[2], "", Udm::CHANGES_LOST_DEFAULT);

		if(CompareObjects(src.GetRootObject(), dst.GetRootObject(), theUmlDiagram)) 
		{
			std::cout<<"These two models are same."<<std::endl;		
			ret = 0;
		}
		else 
		{
			std::cout<<"These two models are different."<<std::endl;		
			ret = 1;
		}

		src.CloseNoUpdate();		
		dst.CloseNoUpdate();
	}
	catch(udm_exception &exc) 
	{
		cerr<<"Exception occured: "<<exc.what()<<endl;
		return -1;
	}

	return ret;
}