/* NAME:	Error Log (Dummy)
 * AUTHOR:	Feng Shi - fengshi@isis-server.isis.vanderbilt.edu
 */
#ifndef __ERRORLOG_H
#define __ERRORLOG_H

#ifdef _MSC_VER
#pragma warning (disable : 4786)
#pragma warning (disable : 4503) 
#endif


#include <string>
#include <fstream>
#include <iostream>

class ErrorLog
{
public:
//	static bool calledbyMaster;
	static std::string filePath;
	static int msgNum;
	static ErrorLog* Instance();
	static ErrorLog* Instance(const std::string& file_path);
	void printLogMsg( const std::string& logMsg)
	{
		if ( logFile.is_open())
		{
			msgNum++;
			logFile << "\t"<<msgNum<<". "<<logMsg << std::endl;
		}
	}
	void printWarning( const std::string& wrnMsg)
	{
		printLogMsg( "WARNING: "+ wrnMsg);
	}
	void printErrorTitle( const std::string& errtitle)
	{
		if ( logFile.is_open())
			logFile << errtitle << std::endl;
	}
	void closeLogFile()
	{
		if ( logFile.is_open())
			logFile.close();
		if (msgNum==0) 
			remove((filePath+ "errorlog.txt").c_str());
	}

protected:
	ErrorLog(){};
	ErrorLog( const std::string& file_path)
	{
		filePath = file_path;
		remove((filePath+ "errorlog.txt").c_str());
		logFile.open( (filePath+ "errorlog.txt").c_str());
	}
	~ErrorLog()
	{
		if ( logFile.is_open() )
			logFile.close();
	}
private:
    static ErrorLog* instance;
	std::ofstream logFile;
};

std::string ErrorLog::filePath = "";
int ErrorLog::msgNum = 0;
ErrorLog* ErrorLog::instance = 0;

ErrorLog* ErrorLog::Instance()
{
    if( instance == 0)
    {
        instance = new ErrorLog();
	}
    return instance;
}

ErrorLog* ErrorLog::Instance(const std::string& file_path)
{
    if( instance == 0)
    {
        instance = new ErrorLog(file_path);
	}
    return instance;
}

// Close log file
extern void closeLogFile()
{
	ErrorLog *log = ErrorLog::Instance();
	log->closeLogFile();
}

extern void printUMTMsg( const std::string& logMsg)
{
	ErrorLog *log = ErrorLog::Instance();
	log->printLogMsg(logMsg);
}
// Prints WARNING+'wrnMsg' to cout and log file, and increment warning counter.
extern void printUMTWarning( const std::string& wrnMsg)
{
	ErrorLog *log = ErrorLog::Instance();
	log->printWarning( wrnMsg);
}

// Prints ERROR+'errMsg' to cout and log file, and increment error counter.
extern void printUMTErrorTitle( const std::string& errtitle)
{
	ErrorLog *log = ErrorLog::Instance();
	log->printErrorTitle( errtitle);
}

#endif //__ERRORLOG_H
